<?php

class com_school_attendance extends ins_com
{
    var $get;
    public function __construct()
    {
        parent::__construct();
        $this->get = ins::_eng()->_get();
    }

    function _get_dormitories($rq)
    {
        $options = [
            "select_type" => "db",
            "select_table" => "com_school_dormitories",
            "select_text" => "title",    "select_vlaue" => "id",
            "select_query" => "`class`='{$rq["class"]}'"
        ];
        return  \ins::_ui()->_html()->_get_select_options($options);
    }


    function _update($rq)
    {
        $data = [
            "dormitory" => $rq["dormitory"],
            "class" => $rq["class"],
            "date" => $rq["date"],
            "attendance" => $rq["attendance"]
        ];

        $w = " `class`='{$rq["class"]}' and  `dormitory`='{$rq["dormitory"]}' and  `date`='{$rq["date"]}' ";
        $o = \ins::_db()->_get_row("com_school_attendance", "*", $w);

        if (is_array($o)) {
            \ins::_db()->_update("com_school_attendance", $data, $w);
        } else {
            \ins::_db()->_insert("com_school_attendance", $data);
        }
    }

    function _getclassUi()
    {
        $data = [
            "start" => ["class" => ' ins_grid',],
            "h4" => ["data" =>  "الصف", "class" => 'ins_col_12 '],
            "date" => ["title" => 'date', "title-ar" => "التاريخ ", "value" =>  date('Y-m-d'), "type" => 'date', "input" => "true", "pclass" => 'ins_col_12'],
            "class" => [
                "title" => 'class', "title-ar" => "الصف", "pclass" => 'ins_col_6',
                "type" => 'select', "select_type" => "db", "select_table" => "com_school_classes"
            ],
            "dormitory" => ["title" => 'dormitory', "title-ar" => "التسكين", "type" => 'select', "pclass" => 'ins_col_6'],
            "line" => [],
            "button" => [
                "data-url" => \ins::_eng()->_url(), "data" =>  "التالى",
                "class" => 'ins_col_6 update_class', "style" => "grid-column-start: 4;"
            ],
            "end" => []
        ];
        return  \ins::_ui()->_data($data)->_render();
    }


    function _header()
    {
        $class =  ins::_db()->_get_row("com_school_classes", "*", "`id`=" . $this->get["mode"]);
        $dormitory =  ins::_db()->_get_row("com_school_dormitories", "*", "`id`=" . $this->get["id"]);
        $data = [
            "start" => [
                "data-class" => $this->get["mode"],
                "data-dormitory" => $this->get["id"],
                "data-date" => $this->get["date"],
                "data-save_msg" => "تم التحديث بنجاح",        
                "class" => ' ins_grid  _header_data'
            ],
            "h4" => ["data" =>  $class["title"], "class" => 'ins_col_4 '],
            "h4-2" => ["data" =>   $dormitory["title"], "class" => 'ins_col_4 '],
            "h4-3" => ["data" => $this->get["date"], "class" => 'ins_col_2 '],
            "a-2" => ["href" => \ins::_eng()->_url([], ["id", "mode", "date"]), "data" => '<i class="fas fa-edit"></i>', "class" => 'ins_col_2 '],
            "line" => [],
            "end" => []
        ];

        return  \ins::_ui()->_data($data)->_render();
    }



    function _create_select($status, $id, $attendance)
    {

        $d = "<select data-id='$id'  class='ins_col_12 _ins_user_attendance' >";

        foreach ($status as $ss) {
            $selected = "";


            if ($attendance  == $ss["id"]) {
                $selected = 'selected="selected"';
            } else   if ($ss["default_status"] == "1") {
                $selected = 'selected="selected"';
            }
            $d .= "<option  $selected  value='" . $ss["id"] . "'  >" . $ss["title"] . "</option>";
        }
        $d .= "</select>";

        return $d;
    }

    function _s_data()
    {

        $status  =  \ins::_db()->_get_data("com_school_attendance_types");

        $table[] = [
            ["data" => "name", "class" => " ins_col_12"],
            ["data" => "status", "class" => "ins_col_6"],
            ["data" => "notes", "class" => "ins_col_6"]
        ];

        $stu =  \ins::_db()->_get_data("app_school_students", "*", "`class`='{$this->get["mode"]}' and `dormitory`='{$this->get["id"]}'");



        $w = " `class`='{$this->get["mode"]}' and  `dormitory`='{$this->get["id"]}' and  `date`='{$this->get["date"]}' ";

        $o = \ins::_db()->_get_row("com_school_attendance", "*", $w);

        if (is_array($o)) {
            $oldata = json_decode($o["attendance"], true);
        }

        foreach ($stu as $s) {

            $thisdata = $oldata[$s["id"]];

            $table[] = [
                ["data" => $s["name"], "class" => " ins_col_12"],
                ["data" => $this->_create_select($status, $s["id"], $thisdata["attendance"]), "class" => "ins_col_6"],
                ["data" =>  "<textarea   class='ins_col_12 _notes_{$s["id"]}' >{$thisdata["notes"]}</textarea>", "class" => "ins_col_6"]
            ];
        }

        $data = [
            "start" => ["class" => ' ins_grid ins_texttocenter'],
            "table_divs" => ["data" => $table, "class" => "ins_col_12"],
            "line" => [],
            "button" => [
                "data-url" => \ins::_eng()->_url(),
                "data" =>  " افترضى",
                "class" => 'ins_col_4  rest_attendance_class'
            ],
            "button-2" => [
                "data-url" => \ins::_eng()->_url(),
                "data" =>  "التالى",
                "class" => 'ins_col_4 update_attendance_class',
                "style" => "    grid-column-start: 9;"
            ],
            "end" => []
        ];


        return  \ins::_ui()->_data($data)->_render();
    }

    function _out()
    {

        $r = "";
        if (isset($this->get["mode"]) &&  isset($this->get["id"])) {
            $r = $this->_header();
            $r .= $this->_s_data();
        } else {
            $r = $this->_getclassUi();
        }

        return  $r;
    }
}
