class Game {
    helper = new Helper();
    game_data = {};
    levels_data = {};
    ui = {
        race: "_l4_race",
        surface: "_l4_select_surface",
        cars: "_l4_select_car",
    };
    step = "cars";
    team = 0;

    _update() {
        var th = this;

        this.helper._get_level_data("four", function(d) {
            th.levels_data = d;
        });

        this.helper._get_game_data(function(d) {
            th.game_data = d;
            th._update_ui();
        });
    }

    _update_ui() {
        var th = this;
        ins(".ins_added_tooltip")._remove();

        th.helper._ajax(th.ui.cars, {}, function(data) {
            ins(".stage")._sethtml(data);
            th._update_ui_select_car();

            ins()._ui._update_ui();
        });
    }

    _update_ui_select_car() {
        var th = this;
        var act_team = ins("._g_team_car")._get(th.team);
        ins("._g_team_car")._removeclass("act");
        ins(act_team)._addclass("act");

        var act_team = ins("._g_team")._get(th.team);
        ins("._g_team")._removeclass("act");
        ins(act_team)._addclass("act");
    }

    _select_car(type, o) {
        var th = this;

        var t = o._getdata("type");
        var c = `_${type}_${t}`;

        var m = ins("._g_team_car.act ._surface_car_data");
        if (m._getdata(type) != null) {

            if (type == "back") {

                var text = "Back"
            } else if (type == "fornt") {

                var text = "Front"

            }
            alert(text + " already selected ");
        }

        m._addclass(c);
        m._setdata(type, t);

        if (m._getdata("fornt") != null && m._getdata("back") != null) {
            if (th.team + 1 == th.game_data.length) {
                th.select_car_end();
            } else {
                th.team++;
                th._update_ui_select_car();
            }
        }
    }

    select_car_end() {
        var th = this;

        th.team = 0;
        th.step = "surface";

        var m = ins("._g_team_car ._surface_car_data");

        var cars_data = [];
        m._each(function(o) {
            cars_data.push(o._getdata());
        });
        ins(".ins_added_tooltip")._remove();

        th.helper._ajax(
            "update_game_data", { type: "car_data", cars_data: JSON.stringify(cars_data) },
            function(data) {
                ins(".stage")._sethtml(data);

                th._update_ui_select_car();
                ins()._ui._update_ui();
            }
        );
    }

    _select_car_surface(o) {
        var th = this;
        var m = ins("._g_team_car.act ._surface_data");

        var t = o._getdata("type");

        m._addclass("_" + t);
        m._setdata("surface", t);

        if (m._getdata("surface") != null) {
            if (th.team + 1 == th.game_data.length) {
                th._select_car_surface_end();
            } else {
                th.team++;
                th._update_ui_select_car();
            }
        }
    }

    _select_car_surface_end() {
        var th = this;

        th.team = 0;
        th.step = "race";

        var m = ins("._g_team_car ._surface_data");

        var surfaces = [];
        m._each(function(o) {
            surfaces.push(o._getdata());
        });
        ins(".ins_added_tooltip")._remove();

        th.helper._ajax(
            "update_game_data", { type: "surface", surface: JSON.stringify(surfaces) },
            function(data) {
                ins(".stage")._sethtml(data);
                th._race_start();
                ins()._ui._update_ui();
            }
        );
    }
    _points = [5, 2, 1, 0];

    _end_level() {
        var th = this;

        var j = [];
        ins("._surface_car_data._car_race")._each(function(o) {
            var tj = { title: o._getdata("team"), a: o._getdata("a") };
            j.push(tj);
        });
        j.sort(function(a, b) {
            return parseFloat(b.a) - parseFloat(a.a);
        });

        var teams_answers = [];
        teams_answers[0] = [];
        var sarts = 3;

        th.game_data.forEach(function(t, i) {
            teams_answers[0][i] = [];
        });

        j.forEach(function(ji) {
            th.game_data.forEach(function(t, i) {
                if (t.title == ji.title) {
                    th.game_data[i]["star"] = sarts;
                    th.game_data[i]["a"] = ji.a;

                    var te = ins("._g_team")._get(i);
                    ins(te)._find("._star")._addclass("wrong");
                    var jj = [];
                    var p = 0;
                    if (sarts == 3) {
                        p = 0;
                    } else if (sarts == 2) {
                        p = 1;
                    } else if (sarts == 1) {

                        p = 2;

                    } else {
                        p = 3;

                    }

                    var old = ins(te)._find("._g_team_points")._gethtml();
                    var n = parseFloat(old) + th._points[p];
                    ins(te)._find("._g_team_points")._sethtml(n);



                    for (var si = 0; si < sarts; si++) {
                        jj.push({ status: "right", time: sarts * -1, "points": n });
                        var _s = ins(te)._find("._star")._get(si);
                        ins(_s)._removeclass("wrong");
                        ins(_s)._addclass("right");
                    }

                    for (var ai = 0; ai < 3; ai++) {
                        if (jj[ai] == null) {
                            jj[ai] = { status: "wrong", time: 0, "points": n };
                        }
                    }
                    teams_answers[0][i] = jj;


                    sarts--;
                }
            });
        });
        th.helper._get_msg("_end_level_msg", {
            title: "Level 4",

            next: "end",
            next_title: "Repeat Level",

            answers: JSON.stringify(teams_answers),
        });
    }

    _race_start() {
        var th = this;

        setTimeout(() => {
            ins("._surface_car_data._car_race")._each(function(o) {
                o._css("right", o._getdata("to"));
            });

            setTimeout(() => {
                th._end_level();
            }, 6000);
        }, 1000);
    }
    run() {
        var th = this;

        ins(".car_fornt")._on("click", function(o) {
            th._select_car("fornt", o);
        });

        ins(".car_back")._on("click", function(o) {
            th._select_car("back", o);
        });
        ins("._car_surface")._on("click", function(o) {
            th._select_car_surface(o);
        });
    }
}