<?php

namespace ins_lib\data;

class datatimeClass
{

    public $_db_datetime_format = "Y-m-d H:i:s";
    public $_db_date_format = "Y-m-d";

    public $_db_month_format = "Y-m";
    public $_html_datetime_format = "Y-m-d\TH:i";







    /**
     * text{last sunday,}
     */


    function _date($text = "", $format = "Y-m-d", $lng = "")
    {
        if ($text != "") {
            $d = date($format, strtotime($text));
        } else {
            $d = date($format);
        }
        if ($lng != "") {
            $d =  $this->_lang_day($d, $lng);
            $d =  $this->_lang_month($d, $lng);
        }
        return $d;
    }


    function _week_information($value)
    {

        $current_week["from"] =  \ins::_data()->_datetime()->_date($value);
        $current_week["to"]  =  \ins::_data()->_datetime()->_date("$value  +6 days");
        $current_week["id"] =    \ins::_data()->_datetime()->_date($value, "W") . \ins::_data()->_datetime()->_date($value, "Y");
        $current_week["days"] =   \ins::_data()->_datetime()->_date_period($current_week["from"], $current_week["to"]);
        $current_week["days"][] = $current_week["to"];


        return $current_week;
    }





    function _date_time($text = "", $format = "Y-m-d H:i:s", $lng = "")
    {
        if ($text != "") {
            $d = date($format, strtotime($text));
        } else {
            $d = date($format);
        }
        if ($lng != "") {
            $d =  $this->_lang_day($d, $lng);
            $d =  $this->_lang_month($d, $lng);
        }
        return $d;
    }


    function _diff($from, $to, $op = "%a")
    {

        $date1 = new \DateTime($from);
        $date2 = new \DateTime($to);
        // echo $from. $date1->format('Y-m-d')."<br/>";
        // echo $to. $date2->format('Y-m-d');
        return  $date2->diff($date1)->format($op);
    }

    function _lang_day($day = "", $lang = "")
    {
        $lang = ($lang != "" ? $lang : \lib::_eng()->_this_lang);
        $days =
            [
                "s" => [
                    "Sat", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri"
                ],
                "ar" => [
                    "sat" => "السبت", "sun" => "الاحد",
                    "mon" => "الاثنين", "tue" => "الثلاثاء",
                    "wed" => "الاربعاء", "thu" => "الخميس",
                    "fri" => "الجمعة",
                ], "en" => [
                    "sat" => "Saturaday", "sun" => "Sunday", "mon" => "Monday", "tue" => "Tuesday",
                    "wed" => "Wednesay", "thu" => "Thursday",
                    "fri" => "Friday",
                ]
            ];

        $d = $day;
        foreach ($days["s"] as $v) {
            $d = str_replace($v, $days[$lang][strtolower($v)],  $d);
        }
        return $d;
    }


    function _lang_month($month = "", $lang = "")
    {
        $lang = ($lang != "" ? $lang : \lib::_eng()->_this_lang);

        $months =
            [
                "s" => [
                    "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                    "jul", "Aug", "Sep", "Oct", "Nov", "Dec"
                ],

                "ar" => [
                    "jan" => "يناير", "feb" => "فبراير", "mar" => "مارس", "apr" => "أبريل", "may" => "مايو", "jun" => "يونيو",
                    "jul" => "يوليو", "aug" => "أغسطس", "sep" => "سبتمبر", "oct" => "أكتوبر", "nov" => "نوفمبر", "dec" => "ديسمبر"
                ], "en" => [
                    "jan" => "jan", "feb" => "feb", "mar" => "mar", "apr" => "apr", "may" => "may", "jun" => "jun",
                    "jul" => "jul", "aug" => "aug", "sep" => "sep", "oct" => "oct", "nov" => "nov", "jun" => "jun"
                ]
            ];



        $d = $month;
        foreach ($months["s"] as $v) {
            $d = str_replace($v, $months[$lang][strtolower($v)],  $d);
        }
        return $d;
    }



    /* date("D M j Y", $d)*/


    /**
     * 
     */
    function _date_period($from, $to, $return_format = "Y-m-d", $p = "P1D")
    {
        $period = new \DatePeriod(
            new \DateTime($from),
            new \DateInterval($p),
            new \DateTime($to)
        );
        $data_d = [];

        foreach ($period as $key => $value) {
            $data_d[] = $value->format($return_format);
        }

        return $data_d;
    }




    /**
     * text{last sunday,}
     */
    function _today($format = "Y-m-d")
    {
        return $this->createDate($format);
    }

    /**
     * text{last sunday,}
     */
    function _now($format = "Y-m-d H:i:s")
    {
        return $this->createDate($format);
    }




    private function createDate($format = "Y-m-d H:i:s")
    {

        return date($format);
    }

    public function _craeteDBDateTime()
    {
        return $this->createDate();
    }

    // <editor-fold defaultstate="collapsed" desc="DataBase">

    function _db_select_between_two_dates_sql($from_date, $to_date, $field = "date")
    {

        $from_date = datatimeClass::dataFormat($from_date);
        $format = 'Y-m-d';

        $from_date = date($format, strtotime($from_date));
        $to_date = date($format, strtotime($to_date));


        return " ( `$field` BETWEEN '" . $from_date . "' AND  '" . $to_date . "') ";
    }

    function select_between_two_dates_sql($field, $from_date, $to_date)
    {

        $from_date = datatimeClass::dataFormat($from_date);
        $format = 'Y-m-d';

        $from_date = date($format, strtotime($from_date));
        $to_date = date($format, strtotime($to_date));


        return " ( $field BETWEEN '" . $from_date . "' AND  '" . $to_date . "') ";
    }

    function create_date($string, $addformat = "Y-m-d")
    {
        return \DateTime::createFromFormat($addformat, $string);
    }

    function dataFormat($date, $format = 'Y-m-d')
    {

        $date = str_replace('/', '-', $date);
        $dd = date($format, strtotime($date));



        return $dd;
    }

    function dateTodb($date)
    {

        return $this->dataFormat($date);
    }

    function dateFromdb($data, $format = "d/m/Y")
    {

        if ($data != "0000-00-00 00:00:00") {
            $timestamp = strtotime($data);
            return date($format, $timestamp);
        } else {

            return "";
        }
    }

    function dateFromdbnew($data)
    {
        $date = date_create_from_format("d/m/Y", $data);
        return ($date);
    }

    function dateTimeFromdb($data)
    {

        /*
          $datas = explode(' ', $data);

          $newdate = explode('-', $datas[0]);

          if (isset($newdate) && $newdate[0] != "") {

          $l = explode(" ", $newdate[2]);

          $dt = $l[0] . "/" . $newdate[1] . "/" . $newdate[0];

          $dt = str_replace('//', '', $dt);
          } else {
          $dt = $data;
          }

         */



        return "";
    }

    function updateDBDates($r, $type = "")
    {

        if ($type != "modified") {


            $r['created'] = date("Y-m-d H:i:s");
        }
        if ($type != "created") {

            $r['modified'] = date("Y-m-d H:i:s");
        }
        return $r;
    }

    function getDate($com)
    {

        $data = $this->db->get_Data($com, "DISTINCT  date", "`enabled`=1 and  `delete`=0");
        $returnData = "";
        foreach ($data as $A) {
            $date = $A['date'];
            $urlTag = $this->createURL($com, "date", $date);
            $returnData .= "<div class='blockitem item date'><a href='" . $urlTag . "'>" . $this->updateDate($date) . "</a></div>";
        }
        return $returnData;
    }

    // </editor-fold>





    function craeteDBDateTime()
    {
        return date("Y-m-d H:i:s");
    }




    function arabicDate($your_date = "")
    {
        $months = array("Jan" => "يناير", "Feb" => "فبراير", "Mar" => "مارس", "Apr" => "أبريل", "May" => "مايو", "Jun" => "يونيو", "Jul" => "يوليو", "Aug" => "أغسطس", "Sep" => "سبتمبر", "Oct" => "أكتوبر", "Nov" => "نوفمبر", "Dec" => "ديسمبر");
        $your_date = $your_date ? $your_date : date('y-m-d'); // The Current Date


        $en_month = date("M", strtotime($your_date));
        foreach ($months as $en => $ar) {
            if ($en == $en_month) {
                $ar_month = $ar;
            }
        }

        $find = array("Sat", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri");
        $replace = array("السبت", "الأحد", "الإثنين", "الثلاثاء", "الأربعاء", "الخميس", "الجمعة");
        $ar_day_format = date('D', strtotime($your_date)); // The Current Day
        $ar_day = str_replace($find, $replace, $ar_day_format);

        header('Content-Type: text/html; charset=utf-8');
        $standard = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9");
        $eastern_arabic_symbols = array("٠", "١", "٢", "٣", "٤", "٥", "٦", "٧", "٨", "٩");
        // $current_date = $ar_day . ' ' . date('d' , strtotime($your_date)) . ' / ' . $ar_month . ' / ' . date('Y' , strtotime($your_date));

        $current_date =  date('d', strtotime($your_date)) . ' <br/> ' . $ar_month;

        $arabic_date = str_replace($standard, $eastern_arabic_symbols, $current_date);

        return $arabic_date;
    }

    function updateDate($data)
    {
        $date = new DateTime($data);


        return $date->format(' l jS F Y');
    }

    function howManyDays($startDate, $endDate)
    {

        $date1 = strtotime($startDate . "");
        $date2 = strtotime($endDate . "");
        $res = (int) (($date2 - $date1) / 86400);

        return $res;
    }

    function howManyDaysTime($startDate, $endDate)
    {

        $date1 = strtotime($startDate);
        $date2 = strtotime($endDate);
        $res = (int) (($date2 - $date1) / 86400);

        return $res;
    }

    function dateStrtotime($startDate, $todb = false)
    {
        if ($todb) {

            $startDate = $this->dateTodb($startDate);
        }
        return strtotime($startDate . " 0:00:00");
    }

    function createDatesArray($strDateFrom, $number_date, $p = "+", $addfromat = "Y-m-d", $Backformat = "Y-m-d")
    {

        $toDate = $this->create_date($strDateFrom, $addfromat);
        if ($p == "-") {
            $strDateTo = date($addfromat, strtotime(date_format($toDate, 'Y-m-d') . "$p$number_date days"));
            return $this->createDateRangeArray($strDateTo, $strDateFrom, $addfromat, $Backformat);
        } else {
            $strDateTo = date($addfromat, strtotime(date_format($toDate, 'Y-m-d') . "$p$number_date days"));
            return $this->createDateRangeArray($strDateFrom, $strDateTo, $addfromat, $Backformat);
        }
    }

    function createDateRangeArray($strDateFrom, $strDateTo, $addfromat = "Y-m-d", $Backformat = "Y-m-d")
    {




        $strDateFrom = $this->create_date($strDateFrom, $addfromat);
        $strDateTo = $this->create_date($strDateTo, $addfromat);



        $aryRange = array();




        $iDateFrom = mktime(1, 0, 0, date_format($strDateFrom, 'n'), date_format($strDateFrom, 'j'), date_format($strDateFrom, 'Y'));
        $iDateTo = mktime(1, 0, 0, date_format($strDateTo, 'n'), date_format($strDateTo, 'j'), date_format($strDateTo, 'Y'));



        if ($iDateTo >= $iDateFrom) {
            array_push($aryRange, date($Backformat, $iDateFrom)); // first entry
            while ($iDateFrom < $iDateTo) {
                $iDateFrom += 86400; // add 24 hours
                array_push($aryRange, date($Backformat, $iDateFrom));
            }
        }
        return $aryRange;
    }
}
