<?php

namespace ins_lib\users;

class usersClass
{

    var $user_table = "sys_users";
    var $group_table = "sys_users_gorups";
    var $setting_table = "sys_users_setting";
    var $role_table = "com_structure_jobs";
    var $role_permissions_table = "com_isd_jobs_permissions";
    var $role_session_var_name = "sys_users_entity";
    var $setting = "";

    public function __construct()
    {

        $this->setting = $this->get_defalut_setting();
    }

    function get_client_ip()
    {
        $ipaddress = '';
        if (getenv('HTTP_CLIENT_IP'))
            $ipaddress = \getenv('HTTP_CLIENT_IP');
        else if (getenv('HTTP_X_FORWARDED_FOR'))
            $ipaddress = \getenv('HTTP_X_FORWARDED_FOR');
        else if (getenv('HTTP_X_FORWARDED'))
            $ipaddress = getenv('HTTP_X_FORWARDED');
        else if (getenv('HTTP_FORWARDED_FOR'))
            $ipaddress = getenv('HTTP_FORWARDED_FOR');
        else if (getenv('HTTP_FORWARDED'))
            $ipaddress = getenv('HTTP_FORWARDED');
        else if (getenv('REMOTE_ADDR'))
            $ipaddress = getenv('REMOTE_ADDR');
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }

    function _create_user($data)
    {

        $data["ip"] = $this->get_client_ip();
        return \lib::_db()->_insert($this->user_table, $data);
    }

    function _update_user($data, $w = "")
    {
        if ($w == "") {
            $w .= "id='" . $data["id"] . "'";
        }
        $data["ip"] = $this->get_client_ip();
        return \lib::_db()->_update($this->user_table, $data, $w);
    }

    function add_user($data)
    {

        $data["ip"] = $this->get_client_ip();


        return \lib::_db()->_insert($this->user_table, $data);
    }

    function get_defalut_setting()
    {

        /*
         * 
         * Array ( [id] => 1 [title] => users setting [alias] => [default] => 1 [sys_order] => 0 [sys_deleted] => 0 [sys_disabled] => 0 [sys_modified] => 2016-10-08 01:58:32 [sys_created] => 2016-10-08 01:57:52 [sys_status] => [new_user_group] => 1 [new_users_status] => 0 [sginup_email] => 1 [forget_password_email] => 2 [new_user_message] => thanks for req [forget_message] => new password sended to your email )
         */
        return \lib::_db()->_get_row($this->setting_table, "*", "`default`='1'");
    }

    function update_password($id = "", $password = "", $passwordType = "")
    {
        $password = $password ? $password : $this->create_password(8, $passwordType);
        \lib::_db()->_update("sys_users", ["password" => md5($password)], "id=:var_id", ["var_id" => $id]);

        return $password;
    }

    function create_password($length = 8, $type = "")
    {
        if ($type == "numbers") {

            $chars = '0123456789';
        } else {
            $chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        }


        $count = mb_strlen($chars);

        for ($i = 0, $result = ''; $i < $length; $i++) {
            $index = rand(0, $count - 1);
            $result .= mb_substr($chars, $index, 1);
        }

        return $result;
    }

    function get_user($get = "all", $by_value = "", $by_field = "id")
    {


        $by_value = $by_value ?: $_SESSION["sys_users_login"];
        $where = " $by_field=:by_value";
        $prepareed = ["by_value" => $by_value];

        $r = \lib::_db()->_get_row($this->user_table, "*", $where, $prepareed);



        if ($get != "all" && $get != "") {
            return $r[$get];
        } else {
            return $r;
        }
    }

    public function _get_user($get = "all", $by_value = "", $by_field = "id")
    {


        $by_value = $by_value ?: $_SESSION["sys_users_login"];
        $where = " $by_field=:by_value";
        $prepareed = ["by_value" => $by_value];

        $r = \lib::_db()->_get_row($this->user_table, "*", $where, $prepareed);



        if ($get != "all" && $get != "") {
            return $r[$get];
        } else {
            return $r;
        }
    }

    function get_group($get = "all", $by_value = "", $by_field = "id")
    {
        $where = " $by_field=:by_value";
        $prepareed = ["by_value" => $by_value];

        $r = \lib::_db()->_get_row($this->group_table, "*", $where, $prepareed);

        if ($get != "all" && $get != "") {
            return $r[$get];
        } else {
            return $r;
        }
    }

    function login($url = "/my/", $password = "", $email = "", $en_password = true)
    {


        $area = \lib::$_area;

        if ($_POST["password"] != "") {

            if ($en_password) {
                $password = $password ? md5($password) : md5($_POST["password"]);
            }





            $login_type = "email";

            if (isset($area["login_user_by"])) {
                $login_type = $area["login_user_by"];
            }



            $email = $email ? $email : $_POST["user_name"];



            $where = "  (password=:var_password and email=:var_email) or   (password=:var_password and  user_name=:var_email) ";




            $prepareed = ["var_password" => $password, "var_password_txt" => $_POST["password"], "var_email" => $email];





            $_user = \lib::_db()->_get_row($this->user_table, "*", $where, $prepareed);



            if (is_array($_user)) {
                if ($_user["ex_data"] != "") {

                    $ex_data = json_decode($_user["ex_data"], true);

                    if ($ex_data[0]["object"] != "") {
                        $_SESSION["sys_users_login_ex_data"] = \lib::_db()->_get_row($ex_data[0]["object"], "*", "id=" .  $ex_data[0]["id"]);
                    }
                }



                $_SESSION["sys_users_login"] = $_user["id"];
                $_SESSION["sys_users_login_data"] = $_user;



                $_SESSION[$this->role_session_var_name] = end(explode(",", $_user["job"]));




                if (isset($url) && $url != "") {
                    \lib::_eng()->redirect($url);
                } else {
                    \lib::_eng()->reload();
                }
            } else {
                \lib::_pages()->_meaasge($this->setting["wrong_login"]);
            }

            return is_array($_user);
        }
    }

    function logout($url = "/")
    {


        if (isset($_SESSION["sys_users_login"])) {
            unset($_SESSION["sys_users_login"]);
            unset($_SESSION["sys_users_login_data"]);

            if (isset($url) && $url != "") {
                \lib::_eng()->redirect($url);
            } else {
                \lib::_eng()->reload();
            }
        }
    }

    function _is_recaptcha()
    {
        $captcha = $_POST['g-recaptcha-response'];
        $response = file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=6LcuFx0UAAAAAJoK_EO7psu9rG4ueiYhpe2sS4im&response=" . $captcha . "&remoteip=" . $_SERVER['REMOTE_ADDR']);
        $obj = json_decode($response);
        return $obj->success;
    }

    function _get($name = "")
    {
        if ($name == "") {
            return $_SESSION["sys_users_login_data"];
        } else {
            return $_SESSION["sys_users_login_data"]["$name"];
        }
    }




    function req_form($redirect = "", $reg_more_inputs = "")
    {

        $r = "";



        if (isset($_POST['do_add_user'])) {

            $_users_data = $this->get_user("all", $_POST["email"], "email");

            if (is_array($_users_data)) {

                $r .= \lib::_pages()->_meaasge($this->setting["new_user_email_error"], "error");
            } else {



                $_POST["group"] = $this->setting["new_user_group"];


                $_POST["sys_enabled"] = $this->setting["new_users_status"];



                $r .= \lib::_pages()->_meaasge($this->setting["new_user_message"]);

                if (isset($_POST["password"])) {

                    $_POST["password"] = md5($_POST["password"]);
                }
                $id = $this->add_user($_POST);
                $new_users_data = $this->get_user("all", $id);
                \lib::_emails()->sendemail($_POST["email"], $this->setting["sginup_email"], $new_users_data);



                if (isset($redirect) && $redirect != "") {
                    \lib::_eng()->redirect($redirect . "do/reg/true/");
                }
            }
        }
        $g = \lib::_eng()->_get();




        $cat__class = "ins_hidden";
        if (isset($g["reg"]) && $g["reg"] == "rec_error") {
            $cat__class = "";
        }


        $fromItems = [
            "div-reg_notes" => ["class" => "reg_notes", "data" => \lib::_data()->_get_gen_word("reg_notes", "users", "", " ")],
            "do_add_user" => ["name" => "do_add_user", "value" => "1", "type" => "hidden", "input" => true],
            "title" => ["required" => "true", "value" => $_SESSION["old_reg_from"]["title"], "type" => "text", "title" => \lib::_data()->_get_gen_word("title", "users"), "input" => true],
            "email" => ["required" => "true", "value" => $_SESSION["old_reg_from"]["email"], "title" => \lib::_data()->_get_gen_word("email", "users"), "input" => true],
            "password" => ["required" => "true", "type" => "password", "pclass" => "col6", "title" => \lib::_data()->_get_gen_word("password", "users"), "input" => true],
            "repassword" => ["type" => "password", "pclass" => "col6", "title" => \lib::_data()->_get_gen_word("repassword", "users"), "input" => true],
            "line" => []
        ];

        /// $reg_more_inputs

        if ($reg_more_inputs != "") {

            $fromItems = array_merge($fromItems, $reg_more_inputs);
        }


        $fromItems["submit"] = ["value" => \lib::_data()->_get_gen_word("send", "users"), "name" => "send", "input" => true];



        $r .= \lib::_ui()->_data([
            "panel" => [
                "title" => \lib::_data()->_get_gen_word("signup", "users"), "class" => "ins_req_panel  $cat__class",
                "data" => \lib::_ui()->_data(
                    ["form ins_grid" => [
                        // "data-jsaction" => "user_req_form",

                        "class" => "user_req_form",
                        "data-passns_msg" => \lib::_data()->_get_gen_word("passns_msg", "users"),
                        "data-email_msg" => \lib::_data()->_get_gen_word("email_msg", "users"),
                        "data" => \lib::_ui()->_data($fromItems)->_render(),
                        "action" => "",
                        "method" =>
                        "post"
                    ]]
                )->_render()
            ]
        ])->_render();


        unset($_SESSION["old_reg_from"]);

        return $r;
    }


    function forget_password($email)
    {
        $_users_data = $this->get_user("all", $email, "email");

        print_R($_users_data);

        if (is_array($_users_data)) {
            $_users_data["password"] = $this->update_password($_users_data["id"]);


            \lib::_pages()->_meaasge($this->setting["forget_message"]);


            \lib::_emails()->sendemail($email, $this->setting["forget_password_email"], $_users_data);
        } else {

            \lib::_pages()->_meaasge($this->setting["wrong_forget"]);
        }
    }


    function forget_form()
    {


        if (isset($_POST['doforget'])) {

            $_users_data = $this->get_user("all", $_POST["email"], "email");

            if (is_array($_users_data)) {
                $_users_data["password"] = $this->update_password($_users_data["id"]);


                \lib::_pages()->_meaasge($this->setting["forget_message"]);


                \lib::_emails()->sendemail($_POST["email"], $this->setting["forget_password_email"], $_users_data);
            } else {

                \lib::_pages()->_meaasge($this->setting["wrong_forget"]);
            }
        }




        $fromItems = [
            // "hidden" => ["name" => "redirect ", "value" => , "input" => true],
            "email" => ["title" => \lib::_data()->_get_gen_word("email", "users"), "input" => true, "pclass" => "ins_col_12"],
            "submit" => ["value" => \lib::_data()->_get_gen_word("send", "users"), "name" => "doforget", "input" => true, "pclass" => "ins_col_12"],
        ];
        return \lib::_ui()->_data([
            "panel" => [
                "title" => \lib::_data()->_get_gen_word("forgetpassword", "users"), "class" => "ins_forget_panel ins_hidden",
                "data" => \lib::_ui()->_data(
                    ["form" => [
                        "data" => \lib::_ui()->_data($fromItems)->_render(),
                        "action" => "", "calss" => "ins_grid",
                        "method" =>
                        "post"
                    ]]
                )->_render()
            ]
        ])->_render();
    }

    function login_form($redirect)
    {



        if (isset($_POST['dologin'])) {

            $this->login($redirect);
        }
        $r = "";
        $g = \lib::_eng()->_get();

        if (isset($g["reg"]) && $g["reg"] == "true") {
            $r .= \lib::_ui()->_data([
                "div-n1" => ["class" => "note info", "data" => \lib::_data()->_get_gen_word("reg_succ", "users")],
            ])->_render();
        }






        $cat__class = "";
        if (isset($g["reg"]) && $g["reg"] == "rec_error") {
            $cat__class = "ins_hidden";
        }

        $area = \lib::$_area;
        $login_type = "email";
        if (isset($area["login_user_by"])) {
            $login_type = $area["login_user_by"];
        }



        $fromItems = [
            "text" => ["title" => \lib::_data()->_get_gen_word("email_user", "users"), "input" => true, "name" => "user_name", "pclass" => "ins_col_12"], "password" => ["title" => \lib::_data()->_get_gen_word("password", "users"), "input" => true, "pclass" => "ins_col_12"], "hidden" => ["name" => "redirect ", "value" => $redirect, "input" => true], "submit" => ["value" => \lib::_data()->_get_gen_word("send_login", "users"), "name" => "dologin", "pclass" => "ins_col_12", "input" => true]
        ];

        $r .= \lib::_ui()->_data([
            "panel" => [/* "title" => \lib::_data()->_get_gen_word("login", "users"), */
                "class" => "ins_login_panel $cat__class ",
                "data" => \lib::_ui()->_data(
                    ["form" => [
                        "data" => \lib::_ui()->_data($fromItems)->_render(),
                        "action" => "", "class" => "ins_grid",
                        "method" =>
                        "post"
                    ]]
                )->_render()
            ]
        ])->_render();

        return $r;
    }

    function user_data($user_id = "")
    {


        $uid = $user_id ?: $_SESSION["sys_users_login"];


        $u = \lib::_db()->_get_data("sys_users", "*", "id=" . $uid)[0];

        $cat_ids = explode(",", $u["cat_id"]);

        $cat_ids = array_filter($cat_ids);


        if ($u["image"] == "") {

            $u["image"] = "/ins_sys/user_avt.png";
        }

        $data = [
            "start" => ["class" => "col12 user_data gray"],
            "img" => ["src" => "/ins_upload/" . $u["image"], "class" => " user_image "],
            "div-title" => ["data" => $u["title"], "class" => "user_title "],
            "div-a" => ["data-jsaction" => "logout", "data" => '<i class="fa fa-power-off" aria-hidden="true"></i>', "style" => ""
                . "    color: red;
    float: left;
    font-size: 19px;
    position: relative;
    top: -12px;
    left: 15px;", "class" => " jsaction logout"],
            "end" => []
        ];





        return \lib::_ui()->_data($data)->_render();
    }

    /**
     * 
     * @param type $data
     * @param type $get
     * @param type $redirect
     * @param type $reg_more_inputs
     * @return boolean
     */
    function security_area(&$data, $get = "all", $redirect = "", $reg_more_inputs = "")
    {

        if ($this->check_user(\lib::$_area)) {
            return true;
        } else {


            $data = "";
            if ($get == "all" || (is_array($get) && in_array("login", $get))) {
                $data .= $this->login_form($redirect);
            }

            if ($get == "all" || (is_array($get) && in_array("forget", $get))) {


                $data .= $this->forget_form($redirect);
            }



            if ($get == "all" || (is_array($get) && in_array("req", $get))) {


                $data .= $this->req_form($redirect, $reg_more_inputs);
            }

            $fromItems = [];


            $g = \lib::_eng()->_get();

            $cat__lgoin = "ins_act";
            $cat__reg = "";

            $fromItems["line-3"] = ["style" => "margin-top: 40px;"];

            if (isset($g["reg"]) && $g["reg"] == "rec_error") {
                $cat__lgoin = "";
                $cat__reg = "ins_act";
            }

            if ($get == "all" || (is_array($get) && in_array("login", $get))) {

                //   $fromItems["label-3"] = ["data" => \lib::_data()->_get_gen_word("login", "users")];
            }

            if ($get == "all" || (is_array($get) && in_array("forget", $get))) {
                $fromItems["label-1"] = [
                    "data" => \lib::_data()->_get_gen_word("forgetpassword", "users"),
                    "class" => "  ins_users_bar",
                ];
            }
            if ($get == "all" || (is_array($get) && in_array("req", $get))) {

                $fromItems["label-2"] = [
                    "data" => \lib::_data()->_get_gen_word("signup", "users"),
                    "class" => "  ins_users_bar"
                ];
            }




            $data .= \lib::_ui()->_data($fromItems)->_render();

            return false;
        }
    }

    function check_user($area = "", $id = "")
    {


        if (isset($_SESSION["sys_users_login"])) {
            //  echo $this->get_user("group");
            $user_area = $this->get_group("per_area", $this->get_user("group"));
            $user_areas = explode(",", $user_area);

            $user_e_areas = explode(",", $this->_role_get("per_area"));


            if ($area["url"] == "" || in_array($area["url"], $user_areas) || in_array($area["url"], $user_e_areas)) {
                return true;
            }
        }
        return false;
    }

    function check_permeation($s_raw, $area = "", $id = "")
    {

        if ($s_raw["permeation"] == "" || $s_raw["permeation"] == "all") {
            return true;
        } else if ($s_raw["permeation"] == "user" && $this->check_user($area, $id)) {
            if ($s_raw["permeation_user_group"] == "") {

                return true;
            } else {

                $permeation_user_group = explode(",", $s_raw["permeation_user_group"]);

                if (in_array($this->get_user("group"), $permeation_user_group)) {

                    return true;
                }
            }
        } else if ($s_raw["permeation"] == "guset" && !$this->check_user($area, $id)) {



            return true;
        }

        return false;
    }

    function _permission_chk($menu = "", $area = "")
    {

        if (isset($_SESSION["sys_users_login"]) || $area == "") {

            if ($area == "") {
                $area = \lib::$_area;
            }
            if ($menu == "") {
                $menu = \lib::_eng()->_getThisMenu;
            }


            $group_data = $this->get_group("all", $this->get_user("group"));


            $components = json_decode($group_data["components"], true);
            foreach ($components as $component) {
                if ($menu["id"] == $component["menu"]) {

                    return true;
                }
            }




            $entities = json_decode($this->_role_get("components"), true);


            foreach ($entities as $entity) {
                if ($menu["id"] == $entity["menu"]) {

                    return true;
                }
            }



            $user_areas = explode(",", $group_data["per_area"]);
            if ($area["url"] == "" || $area["url"] == "root" || (in_array($area["url"], $user_areas) && ($group_data["per_all"] == "1"))) {
                return true;
            }
        }
        return false;
    }

    function _permission_get($menu = "", $area = "")
    {



        if (isset($_SESSION["sys_users_login"])) {

            if ($area == "") {
                $area = \lib::$_area["url"];
            }
            if ($menu == "") {
                $menu = \lib::_eng()->_getThisMenu;
            }

            if ($area == "") {
                $area = "root";
            }



            $group_data = $this->get_group("all", $this->get_user("group"));

            $user_areas = explode(",", $group_data["per_area"]);

            $components = json_decode($group_data["components"], true);
            foreach ($components as $component) {

                if ($menu["id"] == $component["menu"]) {

                    $per_data = $component;
                }
            }






            if ($area == "" || (in_array($area, $user_areas) && ($group_data["per_all"] == "1" || is_array($per_data)))) {
                $per_data["per_all"] = $group_data["per_all"];
                return $per_data;
            }



            if (isset($_SESSION[$this->role_session_var_name])) {

                $entities_data = \lib::_db()->_get_row("com_isd_jobs_permissions", "*", \lib::_data()->_db_get_form_group($_SESSION[$this->role_session_var_name], "entity"));


                $entities = json_decode($entities_data["components"], true);




                foreach ($entities as $entity) {
                    if ($menu["id"] == $entity["menu"]) {
                        if (is_array($per_data)) {
                            $per_data = array_merge($per_data, $entity);
                        } else {
                            $per_data = $entity;
                        }
                        return $per_data;
                    }
                }
            }
        }
        return false;
    }

    function _permission_can($action, $menu = "", $area = "")
    {
        $per_data = $this->_permission_get($menu, $area);
        return ($per_data[$action] == "1" || $per_data["per_all"] == "1");
    }

    function _ex_get($table, $id)
    {
        $w =  "( JSON_CONTAINS(`ex_data`, '{\"id\":\"$id\"}') and JSON_CONTAINS(`ex_data`, '{\"object\":\"$table\"}') )";

        $r = \lib::_db()->_get_data($this->user_table, "*",  $w);
        if (is_array($r)) {
            return $r;
        } else {
            return false;
        }
    }


    function _update_ex($sql_data)
    {

        $table =   $sql_data["ex_table"];
        $id =    $sql_data["ex_id"];



        $ex = ["object" => $table, "id" => $id];
        if (isset($sql_data["password"])) {
            $sql_data["password"] = md5($sql_data["password"]);
        }

        if ($sql_data["do"] == "edit") {
            $r = \lib::_db()->_get_row($this->user_table, "*",  "id='{$sql_data["user_id"]}'");
            $ex_data =  json_decode($r["ex_data"], true);
            $ex_data[] = $ex;
            $sql_data["ex_data"] = json_encode($ex_data);
            $sql_data["id"] = $r["id"];
            \ins::_usere()->_update_user($sql_data);
        } else {
            $ex_data[] = $ex;
            $sql_data["ex_data"] = json_encode($ex_data);
            unset($sql_data["id"]);
            \ins::_usere()->_create_user($sql_data);
        }
    }


    function _delete_ex($sql_data)
    {
        $table = $sql_data["table"];
        $id = $sql_data["id"];
        $user_id = $sql_data["user_id"];
        $r = \lib::_db()->_get_row($this->user_table, "*",  "id='$user_id'");
        $ex_data =  json_decode($r["ex_data"], true);
        foreach ($ex_data as $k => $e_data) {
            if ($e_data["object"] == $table && $e_data["id"] == $id) {
                unset($ex_data[$k]);
            }
        }
        if (count($ex_data) > 0) {



            $r["ex_data"] = json_encode($ex_data);


            \ins::_usere()->_update_user($r);
        } else {
            \ins::_db()->_delete($this->user_table,  "id='$user_id'");
        }
    }

    function _role_get($get)
    {


        if (isset($_SESSION[$this->role_session_var_name])) {
            $r = \lib::_db()->_get_row($this->role_permissions_table, "*", \lib::_data()->_db_get_form_group($_SESSION[$this->role_session_var_name], "entity"));

            if ($get != "all" && $get != "") {
                return $r[$get];
            } else {
                return $r;
            }
        } else {
            return false;
        }
    }


    function _role_all_get($_user, $get = "all")
    {


        $role_session_var_name  = end(explode(",", $_user["job"]));

        if ($role_session_var_name != null) {
            $r = \lib::_db()->_get_row($this->role_permissions_table, "*", \lib::_data()->_db_get_form_group($role_session_var_name, "entity"));

            if ($get != "all" && $get != "") {
                return $r[$get];
            } else {
                return $r;
            }
        } else {
            return false;
        }
    }
}
