<?php

namespace ins_lib\files;

class FilesClass
{

    var $out = "";
    public $_root;

    function __construct()
    {
        $this->_root = dirname(dirname(__DIR__));
    }

    function _get_class($type = "", $myname = "", $options = [])
    {
        $className = '\ins_lib\files\file_' . $type;
        if (class_exists($className)) {
            $a = new $className($myname, $options);

            return $a;
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
    }



    public function _include_pkg_files($dir)
    {



        $r = $this->_include_cssfile($dir);
        $r .= $this->_include_jsfile($dir);
        $this->_include_allPhpfiles([$dir]);



        return $r;
    }

    public function _csv_convert($data)
    {


        $csv = fopen('php://temp/maxmemory:' . (5 * 1024 * 1024), 'r+');




        foreach ($data as $line) {
            $line_data = "";
            $line_data = $line;
            fputcsv($csv, $line_data);
        }
        rewind($fp);
        return stream_get_contents($fp);
    }

    function _copy_file($src, $dst)
    {
        copy($src, $file);
    }

    function _copy_dir($src, $dst)
    {
        if (!defined('DS'))
            define('DS', DIRECTORY_SEPARATOR);
        $dir = opendir($src);

        @mkdir(dirname($dst));
        while (false !== ($file = readdir($dir))) {
            if ($file != '.' && $file != '..') {

                if (is_dir($src . DS . $file)) {
                    $this->_copy_dir($src . DS . $file, $dst . DS . $file);
                } else {


                    copy($src . DS . $file, $dst . DS . $file);
                }
            }
        }
        closedir($dir);
    }

    public function _try_include_Php_file($file)
    {

        $f = $this->_root . "/" . $file . ".php";

        $f = \lib::_data()->_url_clrea($f);


        if (is_file($f)) {
            require_once $f;
        } else {
            return false;
        }
    }

    public function _include_Php_file($file)
    {

        $f = $this->_root . "/" . $file . ".php";

        $f = \lib::_data()->_url_clrea($f);


        if (is_file($f)) {
            require_once $f;
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", " file NoT Found in $f  \n In  " . __CLASS__ . "/" . __FUNCTION__ . "", "001");
        }
    }

    var $file_included = [];
    var $jsfile_included = [];

    public function _include_allPhpfiles($dirs)
    {


        foreach ($dirs as $dir) {

            foreach (glob($this->_root . "/" . $dir . "/*.php") as $filename) {

                require_once $filename;
            }
        }
    }

    public function _include_cssfile($dir, $file = 'style', $prefix = "")
    {
        $this->_include_file("/" . $dir . $prefix, "$file.css");
    }

    public function _include_jsfile($dir, $file = 'script', $prefix = "")
    {
        $this->_include_file("/" . $dir . $prefix, "$file.js");
    }

    public function _include_file($dir, $file = '', $get_to = "head")
    {
        $r = "";
        if (is_array($file)) {
            foreach ($file as $f) {
                $this->_include_($dir, $f, $get_to);
            }
        } else {
            $r = $this->_include_($dir, $file, $get_to);
        }

        return $r;
    }

    private function _include_($dir, $file = '', $get_to = "head")
    {

        $file = $dir  . "/$file";
        $rpath = $this->_root . "/" . $file;
        $rpath = str_replace("//", "/", $rpath);




        if (file_exists($rpath) && !in_array($file, $this->file_included)) {
            array_push($this->file_included, $file);

            $file = \lib::_data()->_url_clrea($file);

            $ext = pathinfo($rpath)["extension"];
            switch ($ext) {
                case "js":
                    $file = "<script src= \"" . $file . "\" ></script>";
                    break;
                case "css":
                    $file = '<link rel="stylesheet" href="' . $file . '" type="text/css"  />';
                    break;
                case "php":
                    require_once $filename;
                    return;
                    break;
            }

            if ($get_to == "head") {
                \lib::_template()->_add_to_headr($file);
            } else {
                echo $file;
            }
        }
        return $file;
    }

    public function _load_js_file($path, $callback)
    {

        ///ins_mods/mod_slider/ins_slider.js 
        return "<script> "
            . " var script = document.createElement('script'); "
            . " script.src = '$path'; "
            . " script.onload = function (e) {  $callback };"
            . "  document.head.appendChild(script);"
            . "  </script>";
    }

    public function _getPath($for)
    {

        $fors = explode("_", $for);
        $r = "";
        $fors[0] = str_replace("/", "", $fors[0]);
        if (in_array($fors[0], \lib::_options()->com_prefs)) {
            $r = \lib::_app_map()->coms_folder;
        } else if (in_array($fors[0], \lib::_options()->mod_prefs)) {
            $r = \lib::_app_map()->mods_folder;
        } else if (in_array($fors[0], \lib::_options()->plg_prefs)) {
            $r = \lib::_app_map()->plgs_folder;
        } else if (in_array($fors[0], \lib::_options()->template_prefx)) {
            $r = \lib::_app_map()->template_folder;
        }
        return $r;
    }

    public function get_path($folder, $name, $url, $area = "", $parent = "", $title = "")
    {

        if ($title == "") {
            $title = $name;
        }
        $r = "<li data-getarea='$area'  data-type='$name' data-parent='$parent' class='ins_data_type'  >" . $title . "</li>";

        return $r;
    }

    public function _get_folder__data($folder, $area = "", $url = "main", $leves = true, $xml_inoftag = "mod")
    {
        $r = "";
        if ($area != "") {
            $marea = "/" . $area;
        }

        $directorio = opendir(\lib::_files()->_root . $marea . $folder);


        while ($fichero = readdir($directorio)) {

            if (!is_dir($fichero)) {

                $path = \lib::_files()->_getPath($fichero) . $fichero . "/properties.xml";

                if (\lib::_files()->_file_exist($path)) {

                    $data22 = \lib::_files()->loadfile($path, "$xml_inoftag")->out;
                }
            }
        }
    }

    public function _get_folder_links($folder, $area = "", $perfix = "", $leves = true, $xml_inoftag = "mod")
    {
        $r = "";


        $marea = "/";

        $directorio = opendir(dirname(dirname(__DIR__)) . $marea . $folder);

        while ($fichero = readdir($directorio)) {
            $data22 = [];


            if (!is_dir($fichero) && strpos($fichero, $perfix) == "0") {

                $path = \lib::_files()->_getPath($fichero) . $fichero . "/properties.xml";

                if (\lib::_files()->_file_exist($path)) {

                    $data22 = \lib::_files()->loadfile($path, "$xml_inoftag")->out;
                }

                $t = "";



                if (isset($data22["$xml_inoftag"]["show"]["data_value"]) && $data22["$xml_inoftag"]["show"]["data_value"] == "false") {
                } else {




                    $r .= "<div class='ins_card ins_col_6 ins_text_tocenter  '>";

                    if (isset($data22["$xml_inoftag"]["title-" . \lib::_eng()->_this_lang]["data_value"])) {

                        $t = $data22["$xml_inoftag"]["title-" . \lib::_eng()->_this_lang]["data_value"];
                    } else if (isset($data22[$xml_inoftag]["title"]["data_value"])) {


                        $t = str_replace($xml_inoftag, "", $data22["$xml_inoftag"]["title"]["data_value"]);
                    }

                    //  $t= $path;

                    $r .= $this->get_path($folder, $fichero, $url, $area, "", $t);

                    if ($leves) {
                        $directorio2 = opendir(\lib::_files()->_root . $marea . $folder . $fichero);



                        while ($fichero2 = readdir($directorio2)) {
                            if (!is_dir($fichero2)) {
                                str_replace(".", "", $fichero2, $count);
                                if ($count == 0) {


                                    if ($fichero2 != "ajax") {
                                        $path = \lib::_files()->_getPath($fichero) . "$fichero/$fichero2/properties.xml";

                                        if (\lib::_files()->_file_exist($path)) {

                                            $data22 = \lib::_files()->loadfile($path, "$xml_inoftag")->out;
                                            if (isset($data22["$xml_inoftag"]["title-" . \lib::_eng()->_this_lang]["data_value"])) {

                                                $t = $data22["$xml_inoftag"]["title-" . \lib::_eng()->_this_lang]["data_value"];
                                            } else if (isset($data22["mod"]["title"]["data_value"])) {
                                                $t = $fichero2;
                                            }
                                        } else {
                                            $t = $fichero2;
                                        }




                                        $r .= $this->get_path($folder, $fichero2, $url, $area, $fichero, $t);
                                    }
                                }
                            }
                        }
                    }
                    $r .= "</div>";
                }
                //in have sub component
            }
        }

        return \lib::_ui()->_data(["type" => 'div', "data" => $r, "class" => "ins_grid"])->_render();;
    }

    public function _get_objects_links($folder, $area = "", $url = "main", $leves = true)
    {
        $r = "";
        if ($area != "") {
            $marea = "/" . $area;
        }

        $directorio = opendir(\lib::_files()->_root . $marea . $folder);



        while ($fichero = readdir($directorio)) {



            if ($leves) {
                $directorio2 = opendir(\lib::_files()->_root . $marea . $folder . $fichero);
                while ($fichero2 = readdir($directorio2)) {


                    if (!is_dir($fichero2)) {

                        if (!is_dir($fichero)) {

                            $r .= "<div class='items_block dirs_blocks blocks'>";





                            str_replace(".", "", $fichero2, $count);
                            if ($count == 0) {
                                if (isset($data["mod"]["show"]) && $data["mod"]["show"] == "false") {
                                } else {
                                    $t = "";
                                    if (isset($data["mod"]["title"]["data_value"])) {
                                        $t = $data["mod"]["title"]["data_value"];
                                    }
                                    $r .= $this->get_path($folder, $fichero2, $url, $area, $fichero, $t);
                                }
                            }
                        }
                    }
                }
                $r .= "</div>";
                //in have sub component
            }
        }

        return \lib::_ui()->_data(
            ["type" => 'ul', "data" => $r]
        )->_render();;
    }




    public function loadfile($fileName, $tag = "", $loadTypes = "", $type = "xml")
    {

        $className = '\ins_lib\files\file_' . $type;

        if (class_exists($className)) {
            $a = new $className();


            $this->out = $a->_load($fileName, $tag, $loadTypes);
        } else {
            \lib::_console()->fatal_error("Class Not found", "libs", "$className No exist", "001");
        }
        return $this;
    }







    /**
     * 
     * @staticvar type $_ui
     * @param type $data
     * @return \ins_lib\files\file_json
     */
    function _json($data = null, $type = "html")
    {
        static $_ui = null;
        if ($_ui === null) {
            $_ui = new \ins_lib\files\file_json();
        }

        return $_ui;
    }





    public function _file_exist($file)
    {

        return file_exists(dirname(dirname(__DIR__)) . "/" . $file);
    }

    public function _is_file($file)
    {

        return file_exists(dirname(dirname(__DIR__)) . "/" . $file);
    }


    public function _get_xml($file, $tag = "", $path  = "/ins_lib/includes/xml/")
    {
        $tag = $tag ? $tag : $file;
        $path =   "$path$file.xml";
        return \lib::_files()->loadfile($path, $tag)->out;
    }
}
