<?php

namespace ins_lib\options;

class app_mabClass
{

    var $area;
    var $_org = [];
    public function __construct()
    {

        $this->coms_folder = "/" . $this->coms_folder;
        $this->mods_folder = "/" . $this->mods_folder;
        $this->plgs_folder = "/" . $this->plgs_folder;
        $this->language_folder = "/" . $this->language_folder;

        $this->upload_folder = "/" . $this->upload_folder;
        $this->upload_images = "/" . $this->upload_images;

        $this->template_folder = $this->template_folder;
        $this->noimage = "/" . $this->noimage;

        $this->libs_folder = "/" . $this->libs_folder;
        $this->url = \lib::_config()->site["url"];

        $this->_org = \ins::_db()->_get_row("com_structure_organization", "*");
    }

    public $resource_folder = "ins_resource/";
    public $coms_folder = "ins_coms/";
    public $mods_folder = "ins_mods/";
    public $plgs_folder = "ins_plgs/";
    public $language_folder = "ins_languages/";
    public $admin_folder = "ins_admin/";
    public $upload_folder = "ins_upload/";
    public $upload_images = "images/";
    public $template_folder = "ins_templates/";
    public $noimage = "ins_images/ins_sys/noimage.png";
    public $ins_images = "ins_images/";
    public $ins_images_sys = "/ins_images/ins_sys/";


    public $template_styles_folder = "styles/";
    public $libs_folder = "ins_lib/";
    public $upload_folder_test = "";
    public $xml_folder = "ins_lib/includes/xml/";
    public $url = "";


    function _clean($path)
    {
        $path = str_replace("//", "/", $path);
        return $path;
    }


    function update_path($path)
    {
        $path = $_SERVER['DOCUMENT_ROOT'] . "/" . $path;
        $path = str_replace("//", "/", $path);
        return $path;
    }

    public function _include_class($class, $parent = "", $area = "")
    {
        if ($area != "") {
            \lib::$_area = \lib::_options()->areas[$area];
        }
        $parent = $parent ? "/" . $parent . "/" : "";

        include_once $this->update_path(\lib::_data()->_get_area() . $this->coms_folder . $parent . $class . "/" . $class . ".php");
    }

    public function _include_module_class($class, $parent = "", $area = "")
    {
        if ($area != "") {
            \lib::$_area = \lib::_options()->areas[$area];
        }
        $parent = $parent ? "/" . $parent . "/" : "";
        include_once $this->update_path(\lib::_data()->_get_area() . $this->mods_folder . $parent . $class . "/" . $class . ".php");
    }

    public function _include_plgin_class($class, $parent = "", $area = "")
    {

        if ($area != "") {
            $area = \lib::_options()->areas[$area]["url"];
        }

        $parent = $parent ? "/" . $parent . "/" : "";
        include_once $this->update_path($area . $this->plgs_folder . $parent . $class . "/" . $class . ".php");
    }



    public function _redirect($url)
    {
        echo "<meta http-equiv=\"refresh\" content=\"0; url=$url\">";
        die();
    }

    public function _reload()
    {
        echo "<meta http-equiv=\"refresh\" content=\"0\">";
        die();
    }
    /**
     * 
     * @param type $add
     * @param type $remove
     * @param type $home
     * @return type
     */
    public function _url($add = [], $remove = [], $home = false)
    {

        $myarray = [];
        $g = $this->_get();


        if (is_array($add)) {

            $myarray = $add + $g;
        } else {
            $myarray = $g;
        }



        $r = "/";

        if ($home || $add == "clear") {
            $def_data = ["area", "site", "alias"];
        } else {
            $def_data = ["area", "site", "alias", "mode", "id"];
        }




        foreach ($def_data as $value) {
            if (isset($myarray[$value]) && $myarray[$value] != "" && $myarray[$value] != "do" && !in_array($value, $remove)) {

                if ($value == "site") {
                    $r .= "site/";
                }
                $r .= $myarray[$value] . "/";
                unset($myarray[$value]);
            }
        }

        foreach ($remove as $m) {
            unset($myarray[$m]);
        }


        if (!$home && $add != "clear" && count($myarray) > 0) {

            $r .= "do/";

            foreach ($myarray as $k => $v) {
                if ($v != "") {
                    if (!in_array($k, $remove) && $myarray[$value] != "do") {
                        $r .= "$k/$v/";
                    }
                }
            }
        }


        $r = \lib::_data()->_url_clrea($r);

        return $r;
    }

    public function _get()
    {
        $data = $_GET;
        if (isset($data["do"])) {
            $vars = explode("/", $data["do"]);
            foreach ($vars as $key => $value) {
                if ($key % 2 == 0) {
                } else {
                    $data[$vars[$key - 1]] = $vars[$key];
                }
            }
        }


        unset($data["do"]);
        return $data;
    }


    public function _org($get = null)
    {

        $d = $this->_org;
        if ($get == null) {
            return  $d;
        } else {
            return  $d[$get];
        }
    }

    public function _currency($code = false, $get = "")
    {
        if ($get == "") {
            $get = $this->_org("default_currency");
        }
        if ($code) {
            return  $get;
        } else {
            $currencies = \ins::_files()->_get_xml("currencies");
            return  $currencies["currencies"][$get]["data_value"];
        }
    }




    /**
     * $type [date,datetime,time,db_date,db_datetime,db_time,db_month,html_date,html_datetime,html_time,html_month]
     */
    public function _format($type = "date", $data = "")
    {
        switch ($type) {
            case "datetime":
            case "date_time":
                $r =  $this->_org("date_time_format");
                break;
            case "time":
                $r =   $this->_org("time_format");
                break;
            case "db_datetime":
                $r =  "Y-m-d H:i:s";
                break;
            case "db_date":
                $r =   "Y-m-d";
                break;
            case "db_month":
                $r =   "Y-m";
                break;
            case "html_month":
                $r =   "Y-m";
                break;
            case "html_date":
                $r =   "Y-m-d";
                break;
            case "html_datetime":
                $r =  "Y-m-d\TH:i";
                break;
            default;
                $r =   $this->_org("date_format");
                break;
        }

        if ($data != "" && $data != "0000-00-00 00:00:00") {
            $timestamp = strtotime($data);
            return date($r, $timestamp);
        } else {

            return  $r;
        }
    }
}
