<?php

namespace ins_lib\pages;

class page_list extends \ins_page
{

    public function __construct($myname = "", $options = [])
    {
        parent::__construct("list", $myname, $options);
        $this->_options = $options;
        $this->_title = $this->getoption("title");

        if (!isset($this->_title) || $this->_title != "") {
            $this->_title = $this->__eng->_getThisMenu["title"];
        }
    }



    private function header()
    {
        $r = "";
        $toolbar = $this->_options["bar_data"];
        $icon = $this->__ui->_data(["type" => "icon", "data" => "retweet"])->_render();
        $toolbar .= $this->__ui->_data([
            "type" => "a", "title" => $this->__eng->_get_gen_word("refresh"), "class" => "refresh", "href" => $this->__eng->_url("clear"),
            "data" => $icon
        ])->_render();


        $r .= $toolbar ? $this->__ui->_data(
            ["type" => "div", "style" => "background:none;", "class" => "ins_toolbar", "data" => $toolbar]
        )->_render() : "";


        $r .= $this->_options["start_data"] ? $this->__ui->_data(
            ["type" => "div", "class" => "start_data", "data" => $this->_options["start_data"]]
        )->_render() : "";



        return $r;
    }

    public function listHeader()
    {
        $r = [];

        $lng = trim(\lib::_eng()->_this_lang);

        $_get = $this->__eng->_get();

        $r[0]["class"] = $this->_list_row_class ? " " . $this->_list_row_class . " " : "";

        $r[0]["style"] = $this->_list_row_style ? " " . $this->_list_row_style . " " : "";



        foreach ($this->_options["start_list"] as $k => $v) {
            $r[0]['data'][$k] = ["class" => "_" . $k . " " . $v["class"], "data" => $k];
        }

        foreach ($this->_list as $k => $v) {

            if (is_array(($this->_pro["list"][$k]))) {
                $v = array_merge($this->_pro["list"][$k], $v);
            }

            $order_name = $k;



            if (isset($v["orderby"])) {

                if ($v["orderby"] == "false") {
                    $order_name = "";
                } else {
                    $order_name = $v["orderby"];
                }
            }

            if (isset($v["title-" . $lng])) {
                $a = $v["title-" . $lng];
            } else if (isset($v["title"])) {
                $a = $v["title"];
            } else if (isset($this->_pro["fields"][$k]["title-" . $lng])) {

                $a = $this->_pro["fields"][$k]["title-" . $lng];
            } else {
                $a = $this->_pro["fields"][$k]["title"];
            }


            $mclass = "";
            $ordertype = "ASC";
            if (isset($_get["order"]) && $_get["order"] == trim($k)) {

                if ($_get["ordertype"] == "ASC") {
                    $ordertype = "DESC";
                    $mclass = "asc_roder ";
                    $a .= '     <i class="fas ins_toright fa-sort-up"></i>';
                } else {
                    $mclass = "desc_roder ";
                    $a .= '     <i class="fas ins_toright fa-sort-down"></i>';
                }
            }



            if ($order_name != "") {

                $href = \lib::_eng()->_url(["ordertype" => $ordertype, "order" => $order_name]);
                $d = \lib::_ui()->_data(["type" => "a", "href" => $href, "data" => $a])->_render();
            } else {
                $d = $a;
            }




            $r[0]['data'][$a] = ["data-k" => $k, "class" => $mclass . " _" . $k . " " . $v["class"], "data" => $d .
                "<i class=\"fas ins_list_move   fa-grip-horizontal\"></i> <i class=\"fas ins_grip  fa-grip-lines-vertical\"></i>"];
        }

        foreach ($this->_options["end_list"] as $k => $v) {
            $r[0]['data'][$k] = ["class" => "_" . $k . " " . $v["class"], "data" => $k];
        }
        return $r;
    }

    public function csv_listHeader()
    {
        $r = [];
        $lng = trim(\lib::_eng()->_this_lang);
        foreach ($this->_options["start_list"] as $k => $v) {

            array_push($r, $k);
        }
        foreach ($this->_list as $k => $v) {


            $v = array_merge($this->_pro["list"][$k], $v);


            if (isset($this->_pro["fields"][$k]["title-" . $lng])) {

                $a = $this->_pro["fields"][$k]["title-" . $lng];
            } else {
                $a = $this->_pro["fields"][$k]["title"];
            }
            array_push($r, $a);
        }
        foreach ($this->_options["end_list"] as $k => $v) {
            array_push($r, $k);
        }
        return $r;
    }

    public function backup()
    {
        $r = [];
        $data = \lib::_db()->_get_data($this->_dbtable);
        $ex_data = [];
        $ex_data["ettings"] = [
            "", "table:" . $this->_dbtable, "count:" . $this->_dbtable, "date:" . date("Y-m-d H:i:s"), "user_id:" . \lib::_usere()->_get("id"), "user_title:" . \lib::_usere()->_get("title")
        ];

        foreach ($data as $k => $v) {
            foreach ($v as $k => $v) {
                $ex_data["h"][] = $k;
            }
            break;
        }

        $ex_data = array_merge($ex_data, $data);

        return $ex_data;
    }

    public function csv_listBody()
    {
        $r = [];
        array_push($r, $this->csv_listHeader());

        foreach ($this->_list_data as $dbData) {
            $h = [];
            foreach ($this->_options["start_list"] as $k => $v) {
                array_push($h, $v["data"]);
            }

            foreach ($this->_list as $k => $v) {


                $v = array_merge($this->_pro["list"][$k], $v);



                $pro = $this->_pro["fields"][$k];

                if (!isset($pro["name"])) {

                    $pro["name"] = $k;
                }
                array_push($h, $this->updaterow_data_csv($pro, $dbData[$pro["name"]], $dbData));
            }


            foreach ($this->_options["end_list"] as $k => $v) {
                array_push($h, $v["data"]);
            }


            array_push($r, $h);
        }

        return $r;
    }

    function update_header_data($k, $v)
    {
    }

    public function _get_list_editable_item($name, $pro, $dbData, $v)
    {
        $history = false;

        if ($v["history"] == "true") {

            $history = true;
        }


        $id = $dbData["id"];

        if ($pro["type"] == "number" || $pro["type"] == "bool") {
            $pro["value"] = $dbData[$pro["name"]];
            $pro["title"] = "";
            $pro["pclass"] = "col11 ";
            $pro["class"] = "insaction ";
            $pro["data-insaction"] = "ins_data_update";
            $pro["data-type"] = $this->_myname;
            $pro["data-name"] = $pro["name"];
            $pro["data-id"] = $dbData["id"];

            if ($history) {
                $pro["data-history"] = "true";
            }


            return \lib::_ui()->_data($pro)->_render();
        } else {
            $more = '';
            if ($history) {
                $more = "data-history=true";
            }



            return "<i class='_update_value'>" . $this->updaterow_data($pro, $dbData[$pro["name"]], $dbData = []) . "</i>"
                . "<div "
                . " class='list_edit jsaction' "
                . " data-jsaction='get_input_update'  "
                . " data-name='$name' "
                . " data-type='" . $this->_myPath . "' "
                . " data-db_table='" . $this->_myname . "' "
                . " data-area='" . \lib::$_area["url"] . "' " . $more
                . " data-id='$id' >"
                . " <i class=\"fa fa-pencil\" aria-hidden=\"true\"></i>"
                . " </div>";
        }
    }

    function updaterow_data_csv($data, $v, $dbData = [])
    {

        $r = $v;
        if ($data["type"] == "select" || $data["type"] == "list") {
            return \lib::_ui()->_data(["select_view" => ["value" => $v, "pro" => $data]])->_render();
        } else if ($data["type"] == "image") {

            return \lib::_ui()->_data(["a" =>
            [
                "value" => $v,
                "href" => $data
            ]])->_render();
        } else if ($data["type"] == "href" || $data["type"] == "link") {


            return "<a href='" . $this->__data->_lang_trans($data["href"], $dbData) . "'>$v</a>";
        } else if ($data["type"] == "labels_area") {

            return "<div class='labels_area' data-obj_id='" . $dbData["id"] . "' data-obj_type='" . $this->_myname . "' ></div>";
        }


        return $r;
    }

    function updaterow_data($data, $v, $dbData = [])
    {
        if ($data["source"] == "json") {

            $d =  json_decode($v, true);
            $v = $d[$data["data"]];
        }
        $r = $v;


        if (($data["type"] == "select" || $data["type"] == "list") && ($data["select_type"] != "template_positions")) {

            return \lib::_ui()->_data(["select_view" => ["value" => $v, "pro" => $data]])->_render();
        } else if ($data["type"] == "editor" || $data["type"] == "textarea" || $data["type"] == "ins_editor" || $data["type"] == "json") {
            return '<i '
                . ' title="' . $data['title'] . '"'
                . ' onclick="ins(\'/ins_ajax.php?get_file=db/get_value&table=' . $this->_dbtable . '&show=' . $data['name'] . '&id=' . $dbData['id'] . '&type=' . $data["type"] . '\')._ajax._url_to_lightbox(this)"   >'
                . '<i class="fa fa-eye" aria-hidden="true"></i></i>';
        } else if ($data["type"] == "editable_select") {
            return \lib::_data()->get_ins_list($data['name'], $v)["text"];
        } else if ($data["type"] == "date") {
            return \ins::_map()->_format("date", $v);
        } else if ($data["type"] == "datetime-local") {
            return \ins::_map()->_format("datetime", $v);
        } else if ($data["type"] == "image") {

            return \lib::_ui()->_data(["image_view" =>
            [
                "value" => $v,
                "class" => "uiaction",
                "data-uiaction" => "tooltip_img",
                "uidata" => "uiaction",
                "pro" => $data
            ]])->_render();
        } else if ($data["type"] == "images") {


            $images = explode(",", $v);
            $images =    array_filter($images);
            $rr = "";
            foreach ($images as $i) {
                $rr .=   \lib::_ui()->_data(["image_view" =>
                [
                    "value" => $i,
                    "class" => "uiaction",
                    "data-uiaction" => "tooltip_img",
                    "uidata" => "uiaction",
                    "pro" => $data
                ]])->_render();
            }
            return $rr;
        } else if ($data["type"] == "url") {
            return "<a  target=\"_blank\" href='" . $v . "'>$v</a>";
        } else if ($data["type"] == "href" || $data["type"] == "link") {
            return "<a href='" . $this->__data->_lang_trans($data["href"], $dbData) . "'>$v</a>";
        } else if ($data["type"] == "labels_area") {

            return "<div class='labels_area' data-obj_id='" . $dbData["id"] . "' data-obj_type='" . $this->_myname . "' ></div>";
        } else if ($data["type"] == "isd") {
            $isd = $dbData;
            $isd["area"] = "root";
            $isd["isd_table"] = $this->_dbtable;
            $isd["isd_table_id"] = $dbData["id"];
            $isd["data"] = "plg_sys_isd";
            $isd["type"] = "plugin";
            $isd["show"] = "list";
            if (isset($data["path"])) {
                $isd["path"] = $data["path"];
            }
            return \lib::_ui()->_data(["plugin" => $isd])->_render();
        } else if ($data["type"] == "plugin") {
            $data["_table"] = $this->_dbtable;
            $data["_id"] = $dbData["id"];
            $data["_show"] = "list";
            unset($data["pclass"]);
            $data["area"] = $data["area"] ? $data["area"] : "root";
            return \lib::_ui()->_data(["plugin" => $data])->_render();
        } else if ($data["type"] == "function") {
            if (!isset($data["name"]) && isset($data["data"])) {
                $data["name"] = $data["data"];
            }
            return call_user_func($data["name"], $data, $dbData);
        } else if ($data["type"] == "select_label") {
            $select_text =   \lib::_ui()->_data(["select_view" => ["value" => $v, "pro" => $data]])->_render();
            $data["data"] = \ins::_data()->_lang_trans($data["data"], ["value" => $v, "select_text" => $select_text]);
            return $data["data"];
        } else if ($data["type"] == "label") {
            $data["data"] = \ins::_data()->_lang_trans($data["data"], ["value" => $v]);
            return $data["data"];
        } else if ($data["type"] == "json_value") {

            $d =  json_decode($v, true);
            return $d[$data["data"]];
        } else if ($data["type"] == "icon") {
            return  "<a href='" . $this->__data->_lang_trans($data["href"], $dbData) . "'><i class='" . $data["icon"] . "'>" . $data["data"] . "</i></a>";
        }
        return $r;
    }

    private function getLimit()
    {
        $r = ($this->_limit) ? $this->_limit : 12;
        if (isset($_SESSION[$this->_myname . "_list_limit"])) {
            $r = $_SESSION[$this->_myname . "_list_limit"];
        }
        return $r;
    }

    private function limitOption()
    {
        $defaultLimit = $this->getLimit();

        return $this->__ui->_data([
            "type" => "select",
            "data-jsname" => $this->_myname . "_list_limit",
            "class" => "list_limit_option  btn",
            "value" => $defaultLimit,
            "data" => [
                "6" => "6",
                "12" => "12",
                "24" => "24",
                "48" => "48",
                "99" => "99",
                "1000000000" => "all"
            ]
        ])->_render();
    }

    private function labels_area($data)
    {
        $filter_Data = \lib::_data()->_get_filter_toarray();

        $htdata = ["start" => ["class" => "filter_labels ins_col_12"]];
        if (isset($filter_Data["sys_labels"])) {
            $htdata["start"]["data-act_label"] = $filter_Data["sys_labels"];
        }
        $htdata["div"] = ["class" => "labels_area_filter ins_grid_24", "style" => "grid-gap: 3px;", "data-type" => $data["name"]];
        $htdata["end"] = [];
        return \lib::_ui()->_data($htdata)->_render();
    }

    private function filter()
    {
        $h = "";
        $filter = $this->_pro["filter"];

        $filter_Data = \lib::_data()->_get_filter_toarray();

        foreach ($filter as $k => $V) {
            $data = $this->_pro["fields"][$k];
            if (isset($data["name"])) {
                $data["name"] = str_replace("[]", "", $data["name"]);
            }


            if (is_array($data)) {
                $data = array_merge($data, $V);
            } else {
                $data = $V;
            }



            if (isset($V["name"])) {
                $data["data-field"] = $V["name"];
            }


            switch ($data["type"]) {
                case "labels_area":
                    $h .= $this->labels_area($data);
                    break;

                default:
                    if (!isset($data["name"])) {
                        $data["name"] = $k;
                    }
                    if (($data["type"] == "list")) {

                        $data["type"] = "select";
                    }
                    $data["data-url"] = $this->__eng->_url([], ["filter", "page"]);
                    $data["pclass"] = $V["class"];
                    $data["class"] = "filter_item";
                    $data["data-field"] = $data['name'];
                    $data["value"] = $filter_Data[$data['name']];

                    // $data["title"] = $data["name"];


                    if ($data["type"] == "select" && $data["select_type"] == "db") {
                        $data["start_empty"] = "true";
                    }

                    if (isset($V["type"]) && $V["type"] == "distinct") {
                        $data["type"] = "select";
                        $data["select_type"] = "db";
                        $data["select_table"] = $this->_myname;
                        $data["select_text"] = $data['name'];
                        $data["select_value"] = $data['name'];
                        $data["select_query_type"] = "distinct";
                    } else if (isset($V["type"])) {


                        $data["type"] = $V["type"];
                        if (isset($V["input"])) {
                            $data["input"] = $V["input"];
                        }
                    }


                    if (isset($V["empty"])) {
                        $emurl = $this->__eng->_url(["filter" => $data['name'] . ";empty"], ["page"]);

                        $data["title"] .= '<a href="' . $emurl . '"><i style="margin-left: 10px;:10px" class="fa  fa-exclamation-circle" aria-hidden="true"></i></a>';
                    }
                    unset($data["style"]);
                    $h .= $this->__ui->_data([$data])->_render();



                    break;
            }
        }




        return $this->__ui->_data(["type" => "div", "data-url" => $this->__eng->_url([], ["filter", "page"]), "class" => "filter_bar ins_filter_bar grid ", "data" => $h])->_render();
    }

    var $mian_attrs = "";
    var $ajax_attrs = "";
    var $ajax_defalut = "";
    var $mian_defalut = "";

    function get_pagination()
    {
        $all = $this->getQuery(true);
        $defaultLimit = $this->getLimit();




        if (isset($this->_get["defaultlimit"])) {
            $defaultLimit = $this->_get["defaultlimit"];
        }

        if (count($all) > $defaultLimit) {
            $p = $this->__ui->_data(["type" => "pagination", "all" => count($all), "limit" => $defaultLimit])->_render();
        }
        $p .= $this->limitOption() . " from ";
        $p .= $this->__ui->_data(["type" => "span", "data" => count($all)])->_render();
        $r = $this->__ui->_data(["type" => "div", "data" => $p, "class" => "ins_pagination_bar"])->_render();
        $r .= $this->_options["end_data"] ? $this->__ui->_data(["type" => "div", "class" => "end_data", "data" => $this->_options["end_data"]])->_render() : "";

        return $r;
    }

    private function getQuery($all = false, $morew = "")
    {
        $l = $this->getLimit();

        $f = 0;

        if (isset($this->_get["defaultlimit"])) {
            $l = $this->_get["defaultlimit"];
        }

        if (isset($this->_get["page"])) {
            $f = ($l * ($this->_get["page"] - 1));
        }
        $filter_Data = \lib::_data()->_get_filter_toarray();
        $op = " ";

        $whereo = "";

        $filter_options = $this->_pro["filter"];

        if ($this->_show_filter != "false") {
            foreach ($filter_Data as $field => $v) {
                $athis_filter = $filter_options[$field];
                if ($v == "empty") {
                    $whereo .= $op . "(`$field` IS NULL OR `$field`= '' )";
                } else if ($field == "sys_labels") {
                    $whereo .= $op . \lib::_data()->_db_get_form_group($v, $field); // $op . "(`$field` like '%$v%')";
                } else if ($filter_options[$field]["type"] == "date_range") {
                    $vs = explode("to", $v);
                    $whereo .= $op . \lib::_data()->_datetime->select_between_two_dates_sql($field, \lib::_data()->_datetime->datetodb(trim($vs[0])), \lib::_data()->_datetime->datetodb(trim($vs[1])));
                } else if ($athis_filter["mode"] == "bridge") {
                    $bridge_data = \lib::_db()->_get_data($athis_filter["bridge_table"], "*", "$field=\"$v\"");
                    if (count($bridge_data) > 0) {
                        $wbd = "(";
                        $wbds = " ";
                        $athis_filter["bridge_field"] = $athis_filter["bridge_field"] ? $athis_filter["bridge_field"] : "id";

                        foreach ($bridge_data as $bd) {
                            $wbd .= $wbds . " `" . $athis_filter["field"] . '`="' . $bd[$athis_filter["bridge_field"]] . '"';
                            $wbds = " or ";
                        }

                        $wbd .= " )";
                    } else {
                        $wbd = "( 1<>1 )";
                    }

                    $whereo .= $op . $wbd;
                } else if (isset($athis_filter["equal"])) {
                    $whereo .= $op . "(`$field` = '$v')";
                } else {

                    $whereo .= $op . "(`$field` like '%$v%')";
                }

                $op = " and  ";
            }
        }







        $_get = $this->__eng->_get();
        $sql_options["limit"]  = " limit $f,$l";
        $sql_options["order"]   = "";


        if (isset($_get["order"])) {
            $sql_options["order"] = " order by " . $_get["order"] . "  ";
        } else if ($this->_query_order_by != "") {
            $sql_options["order"] = " order by " . $this->_query_order_by . "  ";
        } else {
            $sql_options["order"] = " order by {$this->_dbtable}.id  DESC ";
        }


        if (isset($_get["ordertype"])) {
            $sql_options["order"]  .= $_get["ordertype"];
        }

        $ex = $sql_options["order"];
        if (!$all) {
            $ex .= $sql_options["limit"];
        } else {
            $sql_options["limit"] = " ";
        }




        $where = $this->_query ? \lib::_data()->_lang_trans($this->_query) . " and " : "";
        $where .= $whereo != "" ? $whereo . " and " : "";
        $where .= $morew != "" ? $morew . " and " : "";

        if (!$this->_get_deleted) {
            $where .= '(' . $this->_dbtable . '.sys_deleted="0")';
        } else {

            $where .= " 1=1 ";
        }


        $table = $this->_dbtable;

        if (isset($this->_options["page"]["isd"]["data_value"])) {
            $this->_query_custom_data = "$this->_dbtable.*";
            $table .=   \ins::_eng()->_isd()->_get_list_join_query($this->_options["page"]["isd"]["data_value"], $this->_dbtable);
        }


        $query = " select $this->_query_custom_data from   $table  where $where $ex";


        $query = $this->_full_query ? $this->_full_query : $query;

        $query = $this->__data->_lang_trans($query, $sql_options);

        $q_data = \ins::_db()->_get_query($query);
        return $q_data;
    }

    public function listBody()
    {
        $r = [];
        $row = 0;
        $footer = false;



        if (count($this->_list_data) > 0) {

            foreach ($this->_list_data as $dbData) {

                $r[$row]["class"] = $this->_list_row_class ? " " . $this->_list_row_class . " " : "";
                $r[$row]["style"] = $this->_list_row_style ? " " . $this->_list_row_style . " " : "";

                foreach ($this->_options["start_list"] as $k => $v) {
                    $v["data"] = $this->__data->_lang_trans($v["data"], $dbData);
                    $r[$row]['data'][$k] = ["class" => "_" . " " . $v["class"], "data" => $v["data"]];
                }

                foreach ($this->_list as $k => $v) {

                    if (is_array($this->_pro["list"][$k])) {
                        $v = array_merge($this->_pro["list"][$k], $v);
                    }
                    $pro = $this->_pro["fields"][$k];
                    if (is_array($pro)) {
                        $pro = array_merge($pro, $v);
                    } else {
                        $pro = $v;
                    }





                    if (!isset($pro["name"])) {

                        $pro["name"] = $k;
                    }
                    if (is_array($this->_pro["list"][$k]["name"])) {
                        $pro["name"] = $this->_pro["list"][$k]["name"];
                    }


                    $mclass = "";
                    $a = "";

                    if (isset($v["text-befor"])) {
                        $a .= "<span class='listshow text-befor'>" . $v["text-befor"] . "</span>";
                    }

                    if (isset($v["cart-text-befor"])) {
                        $a .= "<span class='cartshow text-befor'>" . $v["cart-text-befor"] . "</span>";
                    }





                    if ($v["editable"] == "true" && $this->__users->_permission_can("edit")) {
                        $mclass .= " editable ";
                        $a .= $this->_get_list_editable_item($k, $pro, $dbData, $v);
                    } else {

                        $val = $this->updaterow_data($pro, $dbData[str_replace("[]", "", $pro["name"])], $dbData);
                        $a .= $val;
                    }

                    if (isset($v["text-after"])) {
                        $a .= "<span class='listshow text-after'>" . $v["text-after"] . "</span>";
                    }


                    if (isset($v["cart-text-after"])) {
                        $a .= "<span class='cartshow text-after'>" . $v["cart-text-after"] . "</span>";
                    }

                    if (isset($v["cart-width"])) {
                        $mclass .= "cart-width-" . $v["cart-width"];
                    }
                    $tr_mclass = "_" . " _" . $k . " $mclass " . $v["class"];



                    $r[$row]["data"][$k . $row] = ["class" => $tr_mclass, "data" => $a];

                    if (isset($this->_pro["list"][$k]["style"])) {

                        $r[$row]["data"][$k . $row]["style"] = $this->_pro["list"][$k]["style"];
                    }


                    if ($pro["type"] == "xref") {
                        $r[$row]["class"] = "tr_xref";
                    }

                    if (isset($pro["footer"])) {
                        $footer = true;
                        if ($pro["footer"] == "sum_currency") {

                            $val = strip_tags($val);
                            if (!is_numeric($this->_pro["list"][$k]["footer_data"])) {
                                $this->_pro["list"][$k]["footer_data"] = 0;
                            }
                            $this->_pro["list"][$k]["footer_data"] += \lib::_data()->_get_number($val);
                        } else if ($pro["footer"] == "sum") {
                            $val = strip_tags($val);

                            if (!is_numeric($this->_pro["list"][$k]["footer_data"])) {
                                $this->_pro["list"][$k]["footer_data"] = 0;
                            }
                            $this->_pro["list"][$k]["footer_data"] += \lib::_data()->_get_number($val);
                        } else if (isset($pro["footer" . "-" . \lib::_eng()->_this_lang])) {
                            $this->_pro["list"][$k]["footer_data"] = $pro["footer" . "-" . \lib::_eng()->_this_lang];
                        } else {
                            $this->_pro["list"][$k]["footer_data"] = $pro["footer"];
                        }
                    }
                }





                foreach ($this->_options["end_list"] as $k => $v) {


                    $v["data"] = $this->__data->_lang_trans($v["data"], $dbData);
                    $r[$row]["data"][$k] = ["class" => " _" . $k . " " . $v["class"], "data" => $v["data"]];
                }



                $row++;
            }
        } else {

            $r["error"]['data'] = [["class" => "ins_col_12 ", "data" => \lib::_eng()->_get_gen_word($this->__eng->_get_gen_word("nodata_msg_error"))]];
        }




        if ($footer) {

            foreach ($this->_pro["list"] as $k => $v) {

                $pro = $this->_pro["fields"][$k];

                if (is_array($pro)) {
                    $pro = array_merge($pro, $v);
                } else {
                    $pro = $v;
                }

                if (isset($pro["footer"])) {

                    if (isset($pro["footer_function"])) {
                        $d = call_user_func($pro["footer_function"], $pro);
                    } else if ($pro["footer"] == "sum_currency") {



                        $d = \lib::_data()->format_currency($pro["footer_data"], $pro["footer_currency_type"]);
                    } else {
                        $d = $pro["footer_data"];
                    }
                } else {
                    $d = "";
                }

                foreach ($this->_options["start_list"] as $ks => $vs) {
                    $r["footer"]["data"][$ks] = ["class" => "_" . " " . $vs["class"], "data" => ""];
                }

                $r["footer"]["class"] = " ins_tr_footer ";

                $r["footer"]["class"] .= $this->_list_row_class ? " " . $this->_list_row_class . " " : "";
                $r["footer"]["style"] .= $this->_list_row_style ? " " . $this->_list_row_style . " " : "";

                $r["footer"]["data"][$k] = ["class" => " _footer_" . $k . " " . $v["class"], "data" => $d];
            }
        }

        return $r;
    }



    function get_table_data()
    {


        $default = $this->_options["page"]["default"]['data_value'];
        if (isset($this->_get["defaultview"])) {
            $default = $this->_get["defaultview"];
        }



        if ($default == "backup") {

            $csv = \lib::_files()->_get_class("csv", $this->_myname, ["data" => $this->backup()]);
            $csv->_export();
            die();
        } else if ($default == "csv") {
            $csv = \lib::_files()->_get_class("csv", $this->_myname, ["data" => $this->csv_listBody()]);
            $csv->_export();
            die();
        } else {


            if (trim($this->_options["page"]["table_header"]["data_value"]) != "false") {

                $tableData = array_merge($this->listHeader(), $this->listBody());
            } else {

                $tableData = $this->listBody();
            }
            $cl = "ins_col_12  $default  ins_view_body  listtable ";

            if (
                isset($this->_options["page"]["block_list_swtitch"]["data_value"])

                && ($this->_options["page"]["block_list_swtitch"]["data_value"] == "card" || $this->_options["page"]["block_list_swtitch"]["data_value"] == "cards")


            ) {

                $cl = "ins_col_12  $default  ins_view_body  listtable  ins_table_cards";
            }



            $table_options = ["type" => "table_divs", "tr_class" => $this->_options["cart_width"], "class" => $cl];


            if (trim($this->_options["page"]["table_header"]["data_value"]) == "false") {
                $table_options["table_header"] = "false";
            } else {

                $table_options["table_header"] = "";
            }
            $table_options["data"] = $tableData;


            if (isset($this->_options["page"]["list_style"])) {
                $table_options["style"] = $this->_options["page"]["list_style"]["data_value"];
            }



            /*
        $filter_Data = \lib::_data()->_get_filter_toarray();
        $op = " ";

        $whereo = "";

        $filter_options = $this->_pro["filter"];*/
            $r = "";
            $filter_Data = \lib::_data()->_get_filter_toarray();

            if (count($filter_Data) > 0) {
                $lang =  trim(\lib::_eng()->_this_lang);
                $filter_Data_text = [];
                foreach ($filter_Data as $k => $v) {

                    if (isset($this->_pro["fields"][$k]["title-" .  $lang])) {
                        $a = $this->_pro["fields"][$k]["title-" .  $lang];
                    } else {
                        $a = $this->_pro["fields"][$k]["title"];
                    }

                    if ($this->_pro["fields"][$k]["type"] == "select" || $this->_pro["fields"][$k]["type"] == "list") {
                        $v = \lib::_ui()->_data(["select_view" => ["value" => $v, "pro" => $this->_pro["fields"][$k]]])->_render();
                    }

                    $filter_Data_text[] = ["value" => $v, "name" => $a];
                }

                $f = "";
                $coma = "";
                foreach ($filter_Data_text as  $v) {
                    $f .= $coma . " {$v["name"]} : {$v["value"]}  ";
                    $coma = ",";
                }
                $f_options = [
                    [
                        "type" => "div", "class" => "ins_col_12 ins_info", "style" => "padding:5px;margin:5px;",
                        "data" => \ins::_eng()->_get_gen_word("filter_msg", "general", "ar") . "<strong>$f</strong>"
                    ]

                ];

                $r .= \ins::_ui()->_data($f_options)->_render();
            }



            $r .= $this->__ui->_data($table_options)->_render();

            return $r;
        }
    }

    public function _render()
    {

        $page = $this->_options["page"];
        \lib::_files()->_include_file($this->_lib_path . "js/", "list_page.js");






        if (isset($_get["ui_mode"])) {
            $this->_options["page"]["default"]["data_value"] = $_get["ui_mode"];
        }




        $this->_list_data = $this->getQuery();

        $r = "";


        if ($this->_render == "all" || $this->_render == "filter") {
            $r .= $this->__ui->_data(["type" => "div", "data-type" => $this->_myname, "class" => "ins_filter_area ins_light ", "data" => $this->filter()])->_render();
        }



        if (trim($page["header"]["data_value"]) != "false") {

            if ($this->_render == "all" || $this->_render == "header") {
                $r .= $this->__ui->_data(["type" => "div", "data-type" => $this->_myname, "class" => "ins_header_area ", "data" => $this->header()])->_render();
            }
        }




        if ($this->_render == "all" || $this->_render == "table_data") {
            $r .= $this->__ui->_data(["type" => "div", "data-type" => $this->_myname, "class" => "ins_table_data_area   ", "data" => $this->get_table_data()])->_render();
        }
        if ($this->_render == "core") {
            $r .= $this->get_table_data();
        }
        if ($this->_render == "all" || $this->_render == "pagination") {
            $r .= $this->__ui->_data(["type" => "div", "data-type" => $this->_myname, "class" => "ins_pagination_area   ", "data" => $this->get_pagination()])->_render();
        }



        if ($this->_render == "all") {

            $ajaxData = '';


            if ($this->_options["ajax"]) {
                $ajaxData = " data-mode='ajax' ";
            }


            $return = "<div  $ajaxData  class='list_mode  " . $this->_myname . " '>";
            $return .= "<div $this->mian_attrs  $this->mian_defalut >$r</div>";


            if ($this->ajax_defalut != "") {
                $return .= "<div  $this->ajax_attrs $this->ajax_defalut > </div>";
            }
            $return .= "</div>";
        } else {

            $return = $r;
        }
        return $return;
    }
}
