<?php

/**
 * Description of xml
 *
 * @author ismail
 */
class ui_chart {

    var $data = null;

    public function __construct($data) {
        $this->data = $data;
    }

    public function _render() {

        return $this->_render_Data($this->data);
    }

    protected function _render_Data($data = "") {


        $fkey = array_keys($data)[0];
        if (is_array($data[$fkey])) {
            foreach ($data as $k => $d) {
                $this->d = $d;
                if (!isset($this->d["type"])) {
                    $ks = explode("-", $k);
                    $this->d["type"] = $ks[0];
                }

                if (!isset($this->d["name"])) {
                    $ks = explode("-", $k);
                    $this->d["name"] = $ks[0];
                }



                $r .= $this->get_chart();
            }
        } else {

            $this->d = $data;
            $r .= $this->get_chart();
        }

        return $r;
    }

    protected function get_chart($data = "") {
        $r = "";
        $h = "";
        $g = "";

        $id = uniqid();
        $lng = trim(\lib::_eng()->_this_lang);
        if ($data != "") {
            $this->d = $data;
        }
        $mclass = "";
        $type = '';
        $h = "";
        switch ($this->d["type"]) {
            case "ColumnChart":
            case "columnChart":
            case "columnchart":
            case "column_chart":
                $g = $this->get_Data($this->d, $id);
                $type = 'ColumnChart';
                $g .= "" .
                        PHP_EOL
                        . " view$id.setColumns(" . PHP_EOL
                        . " ["
                        . "0, 1," . PHP_EOL
                        . " { calc: \"stringify\", sourceColumn: 1,type:\"string\",role: \"annotation\" }," . PHP_EOL
                        . "  2]);
                       ";
                break;
            case "PieChart":
            case "pieChart":
            case "pie_chart":
            case "Pie_Chart":
                $type = 'PieChart';
                $g = $this->get_Data($this->d, $id);
                $g .= "var options$id = {'title':'$title'"
                        . "     
"
                        . ""
                        . "";
                //,pieHole: 0.1

                if (isset($this->d["3d"]) && $this->d["3d"] == "true") {
                    $g .= ",'is3D':true";
                }
                if (isset($this->d["pieHole"])) {
                    $g .= ",'pieHole':" . $this->d["pieHole"];
                }
                if (isset($this->d["sliceVisibilityThreshold"])) {
                    $g .= ",'sliceVisibilityThreshold':" . $this->d["sliceVisibilityThreshold"];
                }





                $g .= "};";
                ;




                break;


            case "LineChart":
            case "LineChart":
            case "LineChart":
            case "LineChart":
                $type = 'LineChart';
                $g = $this->get_Data($this->d, $id);
                $g .= " var options = {
          title: '".$this->d["title"]."',
          curveType: 'function',
          legend: { position: 'bottom' }
        };";
                break;

            case "BarChart":
            case "BarChart":
            case "BarChart":
            case "BarChart":
                $type = 'BarChart';
                $g = $this->get_Data($this->d, $id);
                $g .= " var options = {
          title: '".$this->d["title"]."',
          curveType: 'function',
          legend: { position: 'bottom' }
        };";





                break;


            case "Histogram":
            case "Histogram":
            case "Histogram":
            case "Histogram":
                $type = 'Histogram';
                $g = $this->get_Data($this->d, $id);
                $g .= "    var options = {
          title: '".$this->d["title"]."',
          legend: { position: 'none' },
        };";





                break;
        }

        if ($g != "") {
            $r .= "<script type=\"text/javascript\">" . PHP_EOL
                    . " google.charts.load('current', {'packages':['corechart']});" . PHP_EOL
                    . " google.charts.setOnLoadCallback(drawChart$id);" . PHP_EOL
                    . " function drawChart$id() {" . PHP_EOL
                    . " "
                    . "   var options$id = {
      title: \"$title\",'titleTextStyle': {
      'fontSize': '16'
      },
      bar: {groupWidth: \"95%\"},
      legend: { position: \"none\" }

      };"
                    . ""
                    . "" . PHP_EOL
                    . "$g"
                    . " var chart$id = new google.visualization.$type(document.getElementById(\"$type$id\"));"
                    . "chart$id.draw(view$id, options$id);"
                    . "" . PHP_EOL
                    . "" . PHP_EOL
                    . " }</script>"
                    . "<div id='$type$id' class='" . $this->d["class"] . "' style='" . $this->d["style"] . "'></div>" . PHP_EOL;
        }


        if ($h != "") {

            $r = "<div class = 'ui_value'>$h</div>" . PHP_EOL;
        }


        return $r;
    }

    function get_Data($pro, $id, $type = "arrayToDataTable") {
        $data = $pro["data"];
        $limit = 1000;
        if (isset($pro["limit"])) {
            $limit = $pro["limit"];
        }
        switch ($type) {
            case "arrayToDataTable":
                $r = "var data$id = google.visualization.arrayToDataTable([ " . PHP_EOL;
                $i = 0;
                foreach ($data as $k => $v) {
                    $i++;
                    if ($i <= $limit) {
                        $r .= "[ ";
                        $m = "";
                        foreach ($v as $rv) {
                            $r .= $m . "$rv";
                            $m = ",";
                        }
                        $r .= " ], " . PHP_EOL;
                    }
                }
                $r .= "
      ]);
      
var view$id = new google.visualization.DataView(data$id);

" . PHP_EOL;

                break;

            case "DataTable":
                $r = "view$id.addRows([ " . PHP_EOL;


                foreach ($data as $k => $v) {
                    $m = "";
                    $r .= "[ ";
                    foreach ($v as $rv) {
                        $r .= $m . "$rv";

                        $m = ",";
                    }

                    $r .= " ], " . PHP_EOL;
                }
                $r .= " ]);" . PHP_EOL;


                break;
        }
        return $r;
    }

}
