/* global ins */

//<editor-fold defaultstate="collapsed" desc="InsEditorT">
function InsEditorT() {}

InsEditorT.prototype._msg = {
  undo: " > Undo To @{type}",
  view_updateing: " > View Updating...",
  view_updated: " > View Updated",
  editor_saveing: " > Editor Saving...",
  editor_saved: " > Editor Saved",
  redo: " > Redo To @{type}",
  undo_empty: " > Nothing to Undo",
  redo_empty: " > Nothing to Redo",
  zoom_change: " > Change Zoom To @{value}%",
  code_save_and_update:
    " >  To Update View Press `Ctrl + F8` -  to Update and Fast Save View Press `Ctrl + F9`   and to Save View Press `Ctrl + F10`  ",
  json_error: " > Cancelled Operation (JSON Code Error)",

  clipboard_Format_copied: " > Format copied to clipboard",
  clipboard_Format_update: " > Format applied to selected object",
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="InsEditorUI">
/**
 *
 * @param {ins_ui_editor} o
 * @returns {InsEditorUI}
 */
function InsEditorUI(o) {
  this.editor = o;
  var t = this;
  //<editor-fold defaultstate="collapsed" desc="Events">

  //<editor-fold defaultstate="collapsed" desc="MENU">

  function create_menu(menu, e) {
    e.preventDefault();
    ins(".ui_edtior_contextmenu")._remove();
    var g = ins()._ui._get(menu, "div", {
      class: "ui_edtior_contextmenu ins_menu",
      style: "left:" + e.clientX + "px;top:" + e.clientY + "px;",
    });
    ins("body")._append(g);
    t.editor._history_btns_update();
  }

  ins(".ui_editor_panle_data,.ui_edtior_bar  ")._on(
    "click",
    function (o, e) {
      ins(".ui_edtior_contextmenu")._remove();
    },
    true
  );

  ins(":not(.ins_menu) ")._event("click", function (o, e) {
    ins(".ui_edtior_contextmenu")._remove();
  });

  ins(".ui_editor_view,.ui_object")._on("click", function (o, e) {
    ins(".ui_edtior_contextmenu")._remove();
  });

  ins(".ui_editor_mian_area,.ui_editor_view")._on("contextmenu", function (
    o,
    e
  ) {
    var grid_text = '<i class="fas fa-braille"></i><span>Show Grid</span>';
    if (!ins(".ui_editor_grid")._hasclass("ins_hidden")) {
      grid_text = '<i class="fas fa-braille"></i><span>Hide Grid</span>';
    }
    var editor_menu = [
      {
        name: "li",
        child: '<i class="fas fa-undo"></i>',
        attrs: { class: "ins_col_6 ui_menu_undo ins_text_tocenter" },
        event: [
          "click",
          function () {
            t.editor._history_undo();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      {
        name: "li",
        child: '<i class="fas fa-redo"></i>',
        attrs: { class: "ins_col_6 ui_menu_redo ins_text_tocenter" },
        event: [
          "click",
          function () {
            t.editor._history_redo();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      { name: "li", attrs: { class: "ui_edit_line" }, event: [] },
      {
        name: "li",
        child: '<i class="fas fa-search-plus"></i>',
        attrs: { "data-plus": "0.1", class: "ins_col_4  ins_text_tocenter" },
        event: [
          "click",
          function (e) {
            t.editor._zoom(e);
          },
        ],
      },
      {
        name: "li",
        child: '<i class="fas fa-search"></i>',
        attrs: { "data-value": 1, class: "ins_col_4  ins_text_tocenter" },
        event: [
          "click",
          function (e) {
            t.editor._zoom(e);
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },
      {
        name: "li",
        child: '<i class="fas fa-search-minus"></i>',
        attrs: { "data-minus": "0.1", class: "ins_col_4  ins_text_tocenter" },
        event: [
          "click",
          function (e) {
            t.editor._zoom(e);
          },
        ],
      },
      {
        name: "li",
        child: grid_text,
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._show_hide_grid();

            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },
      { name: "li", attrs: { class: "ui_edit_line" }, event: [] },
      {
        name: "li",
        child: '<i class="fas fa-edit"></i><span> Update View</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._update_view();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },
      {
        name: "li",
        child: '<i class="fas fa-align-right"></i><span> Update Code</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._settings._code_update();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },
      { name: "li", attrs: { class: "ui_edit_line" }, event: [] },
      {
        name: "li",
        child: '<i class="fas fa-eye"></i><span> ui_text_preview </span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      {
        name: "li",
        child: '<i class="fas fa-save"></i><span> Save</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._save();

            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      {
        name: "li",
        child: '<i class="fas fa-file-export"></i><span> Export</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._export();

            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      {
        name: "li",
        child: '<i class="fas fa-file-import"></i> Import</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor.import();

            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      {
        name: "li",
        child: '<i class="fas fa-camera"></i><span> Take Image</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._take_image(function () {});
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },

      { name: "li", attrs: { class: "ui_edit_line" }, event: [] },
      {
        name: "li",
        child: '<i class="fas fa-code"></i><span> Show Console</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            if (ins(".ui_editor")._hasclass("ui_console_area_open")) {
              ins(".ui_editor")._removeclass("ui_console_area_open");
            } else {
              ins(".ui_editor")._addclass("ui_console_area_open");
            }

            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      },
    ];

    create_menu(editor_menu, e);
  });

  ins(".ui_object")._on(
    "contextmenu",
    function (o, e) {
      var settings = t.editor._object._active(o);
      var type = settings.settings.type;
      var ldata = '<i class="fas fa-lock"></i> <span>Unlock </span>';
      if (t.editor.act_object._hasclass("ui_fixed")) {
        ldata = '<i class="fas fa-lock-open"></i> <span>Lock </span>';
      }

      if (!ins(settings.title)._is_empty()) {
        type = settings.title;
      }

      var object_menu = [
        {
          name: "li",
          child: type,
          attrs: { class: "title" },
          event: ["click", function () {}],
        },

        {
          name: "li",
          child: '<i class="fas fa-undo"></i>',
          attrs: { class: "ins_col_6 ui_menu_undo ins_text_tocenter" },
          event: [
            "click",
            function () {
              t.editor._history_undo();

              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },

        {
          name: "li",
          child: '<i class="fas fa-redo"></i>',
          attrs: { class: "ins_col_6 ui_menu_redo ins_text_tocenter" },
          event: [
            "click",
            function () {
              t.editor._history_redo();

              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },

        {
          name: "li",
          child: '<i class="fas fa-copy"></i><span> Duplicate</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._copy();
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },

        ,
        {
          name: "li",
          child: '<i class="fas fa-clone"></i><span> Copy Style</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._style_copy(o, t.editor._object);
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },

        {
          name: "li",
          child: '<i class="fas fa-paste"></i><span> Paste Style</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._style_paste(o, t.editor._object);
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },

        {
          name: "li",
          child: '<i class="fas fa-sync"></i><span> Refresh</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._update();
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },
        {
          name: "li",
          child: '<i class="fas fa-trash"></i><span>Remove</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._remove();
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },
        {
          name: "li",
          child: ldata,
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._lock_unlock();
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        },
        { name: "li", attrs: { class: "ui_edit_line" }, event: [] },
      ];

      if (t.editor.act_object._hasclass("tag_text")) {
        object_menu.push({
          name: "li",
          child: '<i class="far fa-edit"></i> Edit Text</span>',
          attrs: { class: "ins_col_12" },
          event: [
            "click",
            function () {
              t.editor._object._editText(o, t.editor._object);
              ins(".ui_edtior_contextmenu")._remove();
            },
          ],
        });
      }
      object_menu.push({
        name: "li",
        child: '<i class="far fa-check-circle"></i><span> Active</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._object._active(o);
            t.editor._ui._get_toolbar();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      });
      object_menu.push({
        name: "li",
        child: '<i class="fas fa-cog"></i> <span>Settings</span>',
        attrs: { class: "ins_col_12" },
        event: [
          "click",
          function () {
            t.editor._object._get_settings_panel();
            ins(".ui_edtior_contextmenu")._remove();
          },
        ],
      });

      create_menu(object_menu, e);
    },
    true
  );

  //</editor-fold>

  //<editor-fold defaultstate="collapsed" desc="menu_area">

  ins(".uieditor_menu_pkg")._on(
    "change",
    function (e) {
      t._update_menu_area();
    },
    true
  );

  ins(".ui_menu_delete_btn")._on(
    "click",
    function (e) {
      var options = {
        status: e._getdata("status"),
        id: e._getdata("id"),
        cat_id: e._getdata("cat_id"),
      };
      t.editor._ajax(options, function (data) {
        ins(".uieditor_menu_area")._sethtml(data);
        //    t.editor._object._active(act_obj);
      });
    },
    true
  );

  ins(".ui_menu_edit_btn")._on(
    "click",
    function (e) {
      var options = {
        title: "Date Edit",
        style: "width:60%;height:auto;",
        data_style: "height:500px;",
        url:
          "/ins_admin/" +
          e._getdata("alias") +
          "/edit/" +
          e._getdata("id") +
          "/do/get_tmp_index/main_style/onclose/menu_area/parent_id/" +
          e._getdata("cat_id") +
          "/",
        onclose: function () {
          ins_select_manage_update();
        },
      };
      ins()._ui._ins_lightbox(options);
    },
    true
  );

  ins(".ui_menu_action")._on(
    "click",
    function (e) {
      if (ins(e._getdata("status"))._is_exists()) {
        var options = {
          status: e._getdata("status"),
          id: e._getdata("id"),
          cat_id: e._getdata("cat_id"),
        };

        t.editor._ajax(options, function (data) {
          if (e._getdata("status") === "uieditor_menu_edit") {
            t.editor._settings._console_set_ins_code(data);
            t.editor._update_view();
          }
          t._update_menu_area();
        });
      }
    },
    true
  );

  ins(".ui_editor_menu_item ,.ui_editor_menu_item b")._on(
    "click",
    function (e) {
      if (ins(e._getdata("status"))._is_exists()) {
        t._update_menu_data(e);
      }
    },
    true
  );

  ins(".uieditor_menu_add_btn")._on(
    "click",
    function () {
      if (ins(ins(".uieditor_menu_area")._get(0))._is_exists()) {
        var options = {
          status: "uieditor_menu_add",

          data: "{}",
        };
        options[ins(".data_ui_item")._getattr("name")] = ins(
          ".data_ui_item"
        )._getvalue();

        t.editor._ajax(options, function (data) {
          ins(".uieditor_menu_area")._sethtml(data);
        });
      }
    },
    true
  );

  //</editor-fold>

  ins(".ins_ui_colorpanle_add")._on(
    "change",
    function (e) {
      t._update_panel(ins(".ui_editor_items_panel .header li")._index(1));

      ins(".ins_ui_seitems li[data-value='" + e._getvalue() + "']")._remove();
      ins(".ins_ui_seitems")._append(
        '<li class="ui_edit_css e_click ins_ui_colorpanle_item" style="background:' +
          e._getvalue() +
          '" data-name="background" data-value="' +
          e._getvalue() +
          '" name="li">  </li>'
      );

      var options = { status: "addcolor", value: e._getvalue() };

      t.editor._ajax(options, function (data) {});
    },
    true
  );

  ins(".ui_edit_updatepanel")._on(
    "click",
    function (e) {
      t._update_panel(ins(".ui_editor_items_panel .header li")._index(1));
      var options = {
        status: "updatepanel",
        panel: e._getdata("panel"),
        settings: JSON.stringify(t.editor._object._get_settings()),
        name: e._getdata("name"),
        type: e._getdata("type"),
      };
      t.editor._ajax(options, function (data) {
        ins(".ui_editor_items_panel  .ui_editor_properties_data")._sethtml(
          data
        );
        t.after_update_panel();
      });
    },
    true
  );

  ins("input.range")._on("input", function (e) {
    t._update_range_title(e);
  });

  ins(".ui_editor_items_panel .header li")._on(
    "click",
    function (o) {
      t._update_panel(o);
    },
    true
  );

  ins(".ui_editor_sub li")._on(
    "click",
    function (o) {
      t._update_panel(ins(".ui_editor_items_panel .header li")._index(0));
      var options = {
        status: "update_items",
        subcategory: o._getdata("subcategory"),
        category: o._getdata("category"),
      };
      t.editor._ajax(
        options,
        function (data) {
          ins(".ui_editor_items_panel  .ui_editor_items_data")._sethtml(data);
        },
        ".ui_editor_items_panel"
      );
    },
    true
  );

  ins(function () {
    t.editor._ajax({ status: "chk_act_menu" }, function (data) {
      if (data.trim() !== "-1") {
        ins(".uieditor_menu_pkg")._setvalue(data.trim());
        t._update_menu_area(true);
      }
    });
  })._load();

  //</editor-fold>
}

/**
 *
 * @param {ins_editor._t._msg} msg
 * @param {[String]} v
 * @returns {unresolved}
 */

InsEditorUI.prototype.after_update_panel = function () {
  var t = this;
  ins("input.range")._each(function (e) {
    t._update_range_title(e);
  });
};

InsEditorUI.prototype._send_info = function (msg, v) {
  msg = ins(msg)._data._update_variables(v);

  ins(".ui_info_bar")._sethtml("<span class=''>" + msg + "</span>");
  return this.editor;
};

InsEditorUI.prototype._send_info_error = function (msg, v) {
  msg = ins(msg)._data._update_variables(v);
  ins(".ui_info_bar")._sethtml("<span class='ins_error'>" + msg + "</span>");
  return this.editor;
};
InsEditorUI.prototype._send_info_info = function (msg, v) {
  msg = ins(msg)._data._update_variables(v);
  ins(".ui_info_bar")._sethtml("<span class='ins_info'>" + msg + "</span>");
  return this.editor;
};
InsEditorUI.prototype._send_inf_warning = function (msg, v) {
  msg = ins(msg)._data._update_variables(v);
  ins(".ui_info_bar")._sethtml("<span class='ins_warning'>" + msg + "</span>");
  return this.editor;
};

InsEditorUI.prototype._update_menu_data = function (e) {
  t = this;

  var options = {
    status: e._getdata("status"),
    id: e._getdata("id"),
    cat_id: e._getdata("cat_id"),
  };
  t.editor._ajax(options, function (data) {
    t.editor._settings._console_set_ins_code(data);
    t._update_menu_area();

    t.editor._ajax({ status: "uieditor_get_code", type: "css_data" }, function (
      data
    ) {
      t.editor._settings._console_set_code(data);
      t.editor._ajax(
        { status: "uieditor_get_code", type: "js_data" },
        function (data) {
          t.editor._settings._console_set_code(data, "js");

          t.editor._update_view();
        }
      );
    });
  });
};

InsEditorUI.prototype._update_menu_area = function (update_code = false) {
  var t = this;
  if (ins(ins(".uieditor_menu_area")._get(0))._is_exists()) {
    var options = {
      status: "uieditor_menu_update",
      cat_id: ins(".uieditor_menu_pkg")._getvalue(),
    };
    t.editor._ajax(options, function (data) {
      ins(".uieditor_menu_area")._sethtml(data);
      if (update_code === true) {
        t._update_menu_data(ins(".ins_act .ui_editor_menu_item"));
      }
    });
  }
};

InsEditorUI.prototype._update_panel = function (a) {
  var t = this;

  ins(".ins_lightbox")._remove();
  ins(".ui_editor_items_panel .header li")._removeclass("act");
  ins(".ui_editor_items_panel .ui_editor_data")._css({ display: "none" });
  a._addclass("act");
  ins(".ui_editor_items_panel ." + a._getdata("show"))._css({
    display: "block",
  });

  if (ins(a._getdata("action"))._is_exists()) {
    if (a._getdata("action") == "_update_menu_area") {
      t._update_menu_area();
    }
  }
};

InsEditorUI.prototype._update_range_title = function (e) {
  var v = "";
  if (ins(e._getdata("addbeforvalue"))._is_exists()) {
    v = e._getdata("addbeforvalue");
  }
  v = e._getvalue();
  if (ins(e._getdata("addtovalue"))._is_exists()) {
    v += e._getdata("addtovalue");
  }

  var p = e._parents(".ui_range");
  if (ins(p._find(".ui_label span"))._is_exists(true)) {
    p._find(".ui_label span")._settext(v);
  } else {
    p._find(".ui_label")._append("<span>" + v + "</span>");
  }
};

InsEditorUI.prototype._setting_update_panel = function (fn = null) {
  var options = {
    status: "update_settings",
    update_settings_json: "update_settings",
    settings: JSON.stringify(this.editor._object._get_settings()),
  };
  this.editor._ajax(
    options,
    function (data) {
      ins(".ui_editor_items_panel  .ui_editor_properties_data")._sethtml(data);

      if (fn !== null) {
        fn();
      }
      ins()._ui._update_ui();
    },
    ".ui_editor_items_panel"
  );
};

InsEditorUI.prototype._get_toolbar = function (fn = null) {
  var css = "";
  var classes = "";

  if (ins(this.editor.act_object._find(".ui_preview>*"))._is_exists(true)) {
    css = JSON.stringify(
      this.editor.act_object
        ._find(".ui_preview>*")
        ._getcss(["color", "background"])
    );
    classes = JSON.stringify(
      this.editor.act_object._find(".ui_preview>*")._getclasses()
    );
  }

  this.editor._ajax(
    {
      status: "get_toolbar",
      type: this.editor._object._get_settings("toolbar"),
      settings: JSON.stringify(this.editor._object._get_settings()),
      css: css,
      classes: classes,
    },
    function (data) {
      ins(".ui_tool_bar_all .left_items")._sethtml(data);
    }
  );
};

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="InsEditorSettings">
/**
 *
 * @param {ins_ui_editor} o
 * @returns {InsEditorSettings}
 */
function InsEditorSettings(o) {
  this.editor = o;
}

InsEditorSettings.prototype._remove = function (id) {
  this.tree(id, this._get(), null, true);
};

InsEditorSettings.prototype._get = function (id = null) {
  var r = null;
  if (id === null) {
    r = this.editor._data._setting;
  } else {
    r = this.tree(id);
  }
  return r;
};

InsEditorSettings.prototype._update = function (
  id = null,
  settings = null,
  update = false,
  update_code = true
) {
  if (id !== null && settings !== null) {
    if (ins(this._get(id))._is_exists()) {
      this.tree(id, null, settings);
    } else {
      this.editor._data._setting[id] = settings;
    }
  } else if (id === null && settings === null) {
    if (this._console_get_code() != "") {
      this.editor._data._setting = JSON.parse(this._console_get_code());
    }
  } else {
    this.editor._data._setting = settings;
  }

  if (update) {
    this.editor._object._update(ins("#" + id));
  }

  if (update_code) {
    this._code_update();
  }
};

InsEditorSettings.prototype._update_one = function (
  name,
  value,
  update = false,
  id = "",
  subid = null
) {
  if (id === "") {
    id = this.editor.act_object._getattr("id");
  }
  var j = this._get(id);
  this.editor._history_add({
    obj: "",
    type: "drop",
    settings: this.editor._settings._console_get_code(),
    update: false,
  });
  if (subid !== null) {
    if (!ins(j.settings[name])._is_exists()) {
      j.settings[name] = {};
    }
    j.settings[name][subid] = value;
  } else {
    j.settings[name] = value;
  }

  this._update(id, j);
  if (update) {
    this.editor._object._update(ins("#" + id));
  }
  this._code_update();
};

InsEditorSettings.prototype._code_update = function () {
  this.order(ins(".ui_editor_view"));
  this.reordoer_all(this.editor._data._setting);
  this.editor._data._setting = this.reordoer(this.editor._data._setting);
  this._console_set_ins_code(this.editor._data._setting);
};

InsEditorSettings.prototype._code_highlight = function () {
  var data = this._console_get_code();
  var settings = this.editor._settings._get(
    this.editor.act_object._getattr("id")
  );
  var s =
    '"' +
    this.editor.act_object._getattr("id") +
    '": ' +
    JSON.stringify(settings, 0, "\t").trim();
  s = s.replace(/\t/g, "");
  data = data.replace(/\t/g, "");

  data = data.replace(s, '"_highligh_start": "",' + s + ',"_highligh_end": ""');
  this._console_set_ins_code(JSON.parse(data));
  var ui_code_input =
    ".ui_editor_console_ins,.ui_editor_console_css ,.ui_editor_console_js";

  if (ins(ins(ui_code_input)._find(".ui_highlight_code"))._is_exists(true)) {
    ins(ui_code_input)._get(0).scrollTop = ins(ui_code_input)
      ._find(".ui_highlight_code")
      ._p("offsetTop");
  }
};

InsEditorSettings.prototype.isJson = function (str) {
  try {
    JSON.parse(str);
  } catch (e) {
    return false;
  }
  return true;
};
InsEditorSettings.prototype._console_get_code = function (
  clear = true,
  type = "ins"
) {
  var ui_code_input = ".ui_editor_console_" + type;
  var r = "";
  r = ins(ui_code_input)._gethtml().trim();
  if (clear) {
    r = r.replace(/<(.|\n)*?>/g, "");
  }
  if (type != "ins") {
    return r;
  } else {
    if (this.isJson(r)) {
      return r;
    } else {
      console.log("JSONE Erroe");
      return "";
    }
  }
};

InsEditorSettings.prototype._console_format_code = function (
  s,
  code_style = false
) {
  var r = "";
  r = "<pre>" + s.trim() + "</pre>";
  r = r.replace(
    '"_highligh_start": "",',
    "<span  contenteditable='true' class='ui_highlight_code'>"
  );
  var regex = /,\n(.*)highligh_end\":(.*)\"\"/g;
  r = r.replace(regex, "</span>");
  r = r.replace('"ins": "",', "</span>");

  var chrs = ["{", "}", ":", "\\(", "\\)", ";"];
  chrs.forEach(function (a) {
    var n = a.replace("\\", "");

    r = r.replace(
      new RegExp(a, "g"),
      '<span class="ui_chr_code">' + n + "</span>"
    );
  });

  if (code_style) {
    var keys = [
      "_on",
      "ins",
      "alert",
      "_append",
      "_load",
      "_event",
      "_getvalue",
      "_setvalue",
      "var",
      "Math.round",
    ];
    keys.forEach(function (a) {
      var n = a.replace("\\", "");

      r = r.replace(
        new RegExp(a, "g"),
        '<span class="ui_key_code">' + n + "</span>"
      );
    });

    var keys = ["function", "if"];
    keys.forEach(function (a) {
      var n = a.replace("\\", "");

      r = r.replace(
        new RegExp(a, "g"),
        '<span class="ui_key_code">' + n + "</span>"
      );
    });

    /*
         
         var keys = ["}\\);","\;","{"];
         keys.forEach(function (a) {
         var n = a.replace("\\", "");
         r = r.replace(new RegExp(a, 'g'),  n + '\n');
         
         });*/
  }

  return r;
};

InsEditorSettings.prototype._console_set_code = function (a, type = "css") {
  ins(".ui_editor_console_" + type)._sethtml(
    this._console_format_code(a, true)
  );
};

InsEditorSettings.prototype._console_set_ins_code = function (s) {
  var a = "{}";

  if (typeof s === "string") {
    var aj = this.isJson(s.replace(/<(.|\n)*?>/g, "").trim());
    if (aj !== false) {
      a = JSON.stringify(
        JSON.parse(s.replace(/<(.|\n)*?>/g, "").trim()),
        0,
        "\t"
      ).trim();
    } else {
      return false;
    }
  } else {
    a = JSON.stringify(s, 0, "\t").trim();
  }

  var ui_code_input = ".ui_editor_console_ins";

  ins(ui_code_input)._sethtml(this._console_format_code(a));
};

InsEditorSettings.prototype.tree = function (
  id = null,
  obj = null,
  settings = null,
  remove = false
) {
  let r = null;
  var t = this;
  let done = false;
  if (ins(this.editor._data._setting)._is_exists()) {
    if (obj === null) {
      obj = this.editor._data._setting;
    }
    Object.keys(obj).forEach(function (thisid) {
      if (!done) {
        if (id === thisid) {
          done = true;
          if (settings !== null) {
            obj[thisid] = settings;
          }
          if (remove) {
            delete obj[thisid];
          } else {
          }
          r = obj[thisid];
        } else {
          if (
            typeof obj[thisid]["settings"]["data"] !== "string" &&
            !ins(obj[thisid]["settings"]["data"])._is_empty()
          ) {
            r = t.tree(id, obj[thisid]["settings"]["data"], settings, remove);
            if (r !== null) {
              done = true;
            }
          }
        }
      }
    });
  }
  return r;
};

InsEditorSettings.prototype.each = function (func, obj = null) {
  var r = null;
  var t = this;
  if (ins(this.editor._data._setting)._is_exists()) {
    if (obj === null) {
      obj = this.editor._data._setting;
    }
    Object.keys(obj).forEach(function (thisid) {
      func(obj[thisid], Object.keys(obj).length);
      if (
        typeof obj[thisid]["settings"]["data"] !== "string" &&
        !ins(obj[thisid]["settings"]["data"])._is_empty()
      ) {
        r = t.each(func, obj[thisid]["settings"]["data"]);
      }
    });
  }
  return r;
};

InsEditorSettings.prototype.reordoer = function (obj = null) {
  if (ins(obj)._is_exists()) {
    var array = [];
    for (key in obj) {
      var j = obj[key];
      j.key = key;
      array.push(obj[key]);
    }
    array.sort(function (a, b) {
      return a.order - b.order;
    });
    var json = {};
    for (var i = 0; i < array.length; i++) {
      json[array[i]["key"]] = array[i];
    }
    obj = json;
  }
  return obj;
};

InsEditorSettings.prototype.reordoer_all = function (obj = null) {
  var t = this;
  var r = null;
  if (ins(this.editor._data._setting)._is_exists()) {
    if (obj === null) {
      obj = this.editor._data._setting;
    }
    Object.keys(obj).forEach(function (thisid) {
      if (!ins(obj[thisid]["settings"])._is_empty()) {
        if (
          typeof obj[thisid]["settings"]["data"] !== "string" &&
          !ins(obj[thisid]["settings"]["data"])._is_empty()
        ) {
          obj[thisid]["settings"]["data"] = t.reordoer(
            obj[thisid]["settings"]["data"]
          );
          t.reordoer_all(obj[thisid]["settings"]["data"]);
        }
      }
    });
  }
  return r;
};

InsEditorSettings.prototype.getbindex = function (node) {
  var i = 0;
  while ((node = node.previousSibling)) {
    if (
      node.nodeType === 1 &&
      node.classList.contains(this.editor._classes.editor_block_object)
    ) {
      ++i;
    }
  }
  return i;
};

InsEditorSettings.prototype.order = function (p, inx = 0) {
  var t = this;

  if (
    ins(p._find("." + this.editor._classes.editor_block_object))._is_exists()
  ) {
    p._find(".ui_object")._each(function (o, i) {
      var id = o._getattr("id");
      if (ins(t._get(id))._is_exists()) {
        var j = t._get(id);
        j["order"] = t.getbindex(o._get(0));
        j = t._update(id, j, false, false);

        if (
          o._getdata("append") === "inner" &&
          ins(o._find("." + t.editor._classes.editor_block_object))._is_exists()
        ) {
          t.order(o, 0);
        }
        inx++;
      }
    });
  }
};

InsEditorSettings.prototype._setting_options = function (
  id,
  name,
  remove_options = null,
  toggle = true,
  remove = false
) {
  var r = "";

  //  var j = ui_settings_get(id);
  var j = this.editor._settings._get(id);
  if (!ins(j["ui_panel_options"])._is_exists()) {
    j["ui_panel_options"] = {};
  }

  if (ins(remove_options)._is_exists()) {
    if (typeof remove_options === "string") {
      remove_options = remove_options.split(",");
    }
    remove_options.forEach(function (i) {
      if (ins(j["ui_panel_options"][i])._is_exists()) {
        delete j["ui_panel_options"][i];
        ins("*[data-ui_panel_option='" + i + "']")._removeclass("ins_act");
      }
    });
  }

  if (remove || (toggle && ins(j["ui_panel_options"][name])._is_exists())) {
    delete j["ui_panel_options"][name];
    r = "remove";
    ins("*[data-ui_panel_option='" + name + "']")._removeclass("ins_act");
  } else {
    j["ui_panel_options"][name] = true;
    r = "add";

    ins("*[data-ui_panel_option='" + name + "']")._addclass("ins_act");
  }
  this.editor._settings._update(id, j);
  this.editor._settings._code_update();

  return r;
};

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="InsEditorObject">
/**
 *
 * @param {ins_ui_editor} o
 * @returns {InsEditorObject}
 */
function InsEditorObject(o) {
  this.editor = o;
  this.clickCount = 0;
  this.textact = false;
  this.innerdrag = false;
  this.actclass = ins()._data._get_unique_id();
  this.appendPosition = "inner";

  var t = this;

  //<editor-fold defaultstate="collapsed" desc="Evints">

  ins(
    "." +
      t.editor._classes.editor_block +
      "." +
      t.editor._classes.editor_block_container
  )._on(
    "click",
    function (e) {
      t.singleClick(e, t);
    },
    true
  );
  ins(".ui_editor_block_setting_act")._on(
    "click",
    function (e) {
      t._get_settings_panel();
    },
    true
  );

  ins(
    "." +
      t.editor._classes.editor_block +
      "." +
      t.editor._classes.editor_block_data
  )._on(
    "click",
    function (e, event) {
      if (e._hasclass("tag_text")) {
        t.clickCount++;
        if (t.clickCount === 1) {
          singleClickTimer = setTimeout(function () {
            t.clickCount = 0;
            t.singleClick(e, t);
          }, 400);
        } else {
          clearTimeout(singleClickTimer);
          t.clickCount = 0;
          t._editText(e, t);
        }
      } else {
        t.singleClick(e, t);
      }
    },
    true
  );

  ins(".ui_eidtable_div")._on("input", function (o) {
    t.editor._settings._update_one(
      "data",
      ins(".ui_eidtable_div")._gettext(),
      false
    );
  });

  ins(".ui_editor_view")._on(
    "click",
    function (e, ev) {
      if (
        ins(ins(".ui_eidtable_div")._get(0))._is_exists() &&
        ev.target !== ins(".ui_eidtable_div")._get(0)
      ) {
        textact = false;
        ins(".ui_eidtable_div")._removeattr("contenteditable");
        ins(".ui_eidtable_div")._removeclass("ui_eidtable_div");
        ins(".ui_p_eidtable_div")._removeclass("ui_p_eidtable_div");
      }
      if (
        ins(
          ins("." + t.editor._classes.editor_block_act)._get(0)
        )._is_exists() &&
        ev.target !== t.editor.act_object._get(0) &&
        !t.editor.act_object._is_in_childs(ev.target)
      ) {
        ins("." + t.editor._classes.editor_block_act)._removeclass(
          t.editor._classes.editor_block_act
        );
      }
      ins(".ui_tool_bar_all .left_items")._sethtml("");
    },
    true
  );

  ins(".ui_editor_block_move ,.ui_editor_block_move i")._on(
    "mousedown",
    function (o, e) {
      if (!t.editor.ui_object_act_disabled) {
        o._parents("." + t.editor._classes.editor_block_object)._setattr(
          "draggable",
          "true"
        );
      }
    }
  );

  ins(".ui_editor_block_move ,.ui_editor_block_move i")._on(
    "mouseup",
    function (o, e) {
      if (!t.editor.ui_object_act_disabled) {
        o._parents("." + t.editor._classes.editor_block_object)._removeattr(
          "draggable"
        );
      }
    }
  );

  //<editor-fold defaultstate="collapsed" desc="Drag Drop">

  //</editor-fold>

  ins(".ui_edit_class.e_click")._on(
    "click",
    function (e) {
      t._ui_edit_class(e, t);
    },
    true
  );
  ins(".ui_edit_class.e_input")._on(
    "input",
    function (e) {
      t._ui_edit_class(e, t);
    },
    true
  );
  ins(".ui_edit_class.e_change")._on(
    "change",
    function (e) {
      t._ui_edit_class(e, t);
    },
    true
  );

  ins(".ui_edit_setting.e_input")._on("input", function (e) {
    t._ui_edit_setting(e, t);
  });
  ins(".ui_edit_setting.e_click")._on(
    "click",
    function (e) {
      t._ui_edit_setting(e, t);
    },
    true
  );
  ins(".ui_edit_setting.e_change")._on("change", function (e) {
    t._ui_edit_setting(e, t);
  });

  ins(".ui_edit_css.e_input")._on("input", function (e) {
    t._ui_edit_css(e, t);
  });
  ins(".ui_edit_css.e_change")._on("change", function (e) {
    t._ui_edit_css(e, t);
  });
  ins(".ui_edit_css.e_click")._on(
    "click",
    function (e) {
      t._ui_edit_css(e, t);
    },
    true
  );

  ins(".ui_edit_style.e_click")._on(
    "click",
    function (e) {
      t._ui_edit_style(e, t);
    },
    true
  );
  ins(".ui_edit_style.e_input")._on("input", function (e) {
    t._ui_edit_style(e, t);
  });
  ins(".ui_edit_style.e_change")._on("change", function (e) {
    t._ui_edit_style(e, t);
  });

  this.fireRate = 20;
  this.fireInterval = null;

  ins(".ui_edit_css.e_mousedown")._on(
    "mousedown",
    function (e) {
      t.ui_edit_css(e, t);
      t.fireInterval = setInterval(function () {
        t.ui_edit_css(e, t);
      }, 1000 / t.fireRate);
    },
    true
  );
  ins(".ui_edit_css.e_mousedown")._on(
    "mouseup",
    function (e) {
      clearInterval(t.fireInterval);
    },
    true
  );

  ins(".ui_editor_block")._on(
    "mouseover",
    function (e) {
      if (!t.editor.ui_object_act_disabled) {
        var settings = t.editor._settings._get(e._getattr("id"));
        if (ins(settings)._is_empty()) {
          t.editor._settings._update();
        }

        if (ins(settings.settings)._is_exists()) {
          e._find(".ui_editor_block_tool_bar .title")._settext(
            settings.settings.type
          );
        }
        e._addclass("ui_object_highlight");
      }
    },
    true
  );

  ins(".ui_editor_block")._on(
    "mouseout",
    function (e) {
      e._removeclass("ui_object_highlight");
    },
    true
  );

  //</editor-fold>
}

//<editor-fold defaultstate="collapsed" desc="comment">

InsEditorObject.prototype.singleClick = function (e, t) {
  if (!t.editor.ui_object_act_disabled) {
    t._active(e);
    t.editor._ui._get_toolbar();
  }
};

InsEditorObject.prototype._editText = function (o, t) {
  if (o._hasclass("tag_text")) {
    var ob = o._find(".editable_text");
    // t.textact = true;
    o._addclass("ui_p_eidtable_div");
    ob._addclass("ui_eidtable_div");
    ob._setattr("contenteditable", "true");
    ob._get(0).focus();
    t._active(o);
  }
};

InsEditorObject.prototype._set = function (obj) {
  this.editor.act_object = obj;
};

InsEditorObject.prototype._get = function (defulit = null) {
  var o = this.editor.act_object;
  if (defulit !== null) {
    o = defulit;
  }
  return o;
};

InsEditorObject.prototype.parseScript = function (strcode) {
  /* www.webdeveloper.com */
  var scripts = new Array(); // Array which will store the script's code

  // Strip out tags
  while (strcode.indexOf("<script") > -1 || strcode.indexOf("</script") > -1) {
    var s = strcode.indexOf("<script");
    var s_e = strcode.indexOf(">", s);
    var e = strcode.indexOf("</script", s);
    var e_e = strcode.indexOf(">", e);

    // Add to scripts array
    scripts.push(strcode.substring(s_e + 1, e));
    // Strip from strcode
    strcode = strcode.substring(0, s) + strcode.substring(e_e + 1);
  }

  // Loop through every script collected and eval it
  for (var i = 0; i < scripts.length; i++) {
    try {
      eval(scripts[i]);
    } catch (ex) {
      // do what you want here when a script fails
    }
  }
};

InsEditorObject.prototype._update = function (p = null, tho = null) {
  p = this._get(p);
  var t = this;

  var options = {
    append: p._getdata("append"),
    update_date: true,
    status: "block",
    data_file: ins(".ui_editor_view")._getdata("file"),
    data: JSON.stringify(this.editor._settings._get(p._getattr("id"))),
  };
  this.editor._ajax(
    options,
    function (data) {
      p._find(".ui_preview")._sethtml(data);
      t.parseScript(data);
      if (!ins(tho)._is_empty()) {
        if (!ins(tho._getdata("ui_callback"))._is_empty()) {
          window[tho._getdata("ui_callback")](p, tho);
        }
      }
    },
    p
  );
};

InsEditorObject.prototype._active = function (o) {
  ins(".ui_help_bar")._sethtml("");
  this._set(o);

  var t = this;

  ins("." + this.editor._classes.editor_block_act)._removeclass(
    this.editor._classes.editor_block_act
  );
  this.editor.act_object._addclass(this.editor._classes.editor_block_act);
  var settings = this.editor._settings._get(
    this.editor._object._get()._getattr("id")
  );
  if (ins(settings)._is_exists()) {
    this.editor._settings._code_highlight();

    var v =
      "<ul class='ui_eidor_item_data'>\n\
     <li class='ui_eidor_item_data_row'><span  class='ui_eidor_item_data_name' > Type: </span><spane class='ui_eidor_item_data_value'>" +
      settings.settings.type +
      "</span></li>";
    v +=
      "<li class='ui_eidor_item_data_row' ><span class='ui_eidor_item_data_name'> ID: </span><spane class='ui_eidor_item_data_value'>" +
      this.editor.act_object._getattr("id") +
      "</span></li>";
    v +=
      "<li class='ui_eidor_item_data_row' ><span  class='ui_eidor_item_data_name' > class: </span><spane class='ui_eidor_item_data_value'>" +
      settings.settings.pclass +
      "</span></li></ui>";

    this._remove_anchors();
    ins(".ui_edtior_act_info")._sethtml(v);
    if (this.editor.act_object._hasclass("ui_fixed")) {
      this.editor.act_object._addclass("ins_act_fixed");
      this._unlock();

      this.editor._ajax(
        { status: "get_toolbar", type: "toolbar_anchors" },
        function (data) {
          ins(".ui_help_bar")._sethtml(data);

          ins(".ui_anchor_height")._setvalue(
            t.editor.act_object._p("clientHeight")
          );

          ins(".ui_anchor_width")._setvalue(
            t.editor.act_object._p("clientWidth")
          );
          ins(".ui_anchor_top")._setvalue(t.editor.act_object._p("offsetTop"));
          ins(".ui_anchor_left")._setvalue(
            t.editor.act_object._p("offsetLeft")
          );
          ins(".ui_anchor_rotate")._setvalue(
            t._get_transform_value("rotate", ["deg"], 0)
          );
        }
      );
    }

    return settings;
  }
};

InsEditorObject.prototype._get_settings = function (name = null, obj = null) {
  obj = this._get(obj);
  if (name === null) {
    return this.editor._settings._get(obj._getattr("id"));
  } else {
    var j = this.editor._settings._get(obj._getattr("id"));
    return j[name];
  }
};

InsEditorObject.prototype._remove = function (o = null) {
  o = this._get(o);

  this.editor._history_add({
    obj: "",
    type: "Remove",
    settings: this.editor._settings._console_get_code(),
    update: true,
  });
  this.editor._settings._remove(o._getattr("id"));
  o._remove();
  this.editor._settings._code_update();
};

InsEditorObject.prototype._get_settings_panel = function () {
  this.editor._ui._update_panel(
    ins(".ui_editor_items_panel .header li")._index(1)
  );
  this.editor._ui._setting_update_panel();
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="_ui_edit">

//<editor-fold defaultstate="collapsed" desc="setting">

InsEditorObject.prototype._ui_edit_setting = function (e, t) {
  var v = "";
  if (ins(e._getdata("value"))._is_empty()) {
    v = e._getvalue();
  } else {
    v = e._getdata("value");
  }
  if (e._getdata("name") == "pstyle") {
    t.editor.act_object._setattr("style", v);
  }
  if (e._getdata("name") == "pclass") {
    var classtype = " " + v;

    if (t.editor.act_object._getdata("append") == "inner") {
      classtype +=
        " " +
        t.editor._classes.editor_block_object +
        "  " +
        t.editor._classes.editor_block_container;
    } else {
      classtype +=
        " " +
        t.editor._classes.editor_block_object +
        "  " +
        t.editor._classes.editor_block_data;
    }

    t.editor.act_object._setattr("class", "ui_editor_block  " + classtype);
  }

  if (e._getdata("ui_panel_option")) {
    t.editor._settings._setting_options(
      act_obj._getattr("id"),
      e._getdata("ui_panel_option"),
      e._getdata("ui_panel_option_remov")
    );
  }

  t.editor._settings._update_one(e._getdata("name"), v, true);
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="_classes">

InsEditorObject.prototype._update_settings_classes = function (
  c = null,
  update = false
) {
  c = this._get(c);
  this.editor._settings._update_one(
    "pclass",
    c._getclasses(" ", [
      this.editor._classes.editor_block,
      this.editor._classes.editor_block_container,
      this.editor._classes.editor_block_data,
      ,
      this.editor._classes.editor_block_object,
    ]),
    update
  );
};

InsEditorObject.prototype._change_class = function (
  name,
  remove = null,
  toggel = null,
  update = false
) {
  var status = true;
  var c = this.editor.act_object;
  if (remove !== null) {
    remove.forEach(function (rr) {
      c._removeclass(rr);
    });
  }
  var names = name.split(" ");
  if (ins(toggel)._is_exists()) {
    names.forEach(function (i) {
      if (ins(c._get(0))._hasclass(i)) {
        ins(c._get(0))._removeclass(i);
        status = false;
      } else {
        c._addclass(i);
      }
    });
  } else {
    names.forEach(function (i) {
      c._addclass(i);
    });
  }

  this._update_settings_classes(c, update);
  return status;
};

InsEditorObject.prototype._ui_edit_class = function (e, t) {
  var c = "";
  if (ins(e._getdata("addbeforvalue"))._is_exists()) {
    c = e._getdata("addbeforvalue");
  }
  if (ins(e._getdata("uichangeclass"))._is_empty()) {
    c += e._getvalue();
  } else {
    c += e._getdata("uichangeclass");
  }

  if (ins(e._getdata("addtovalue"))._is_exists()) {
    c = e._getdata("addtovalue");
  }

  r = null;
  if (ins(e._getdata("remove"))._is_exists()) {
    remove = e._getdata("remove").split(",");
    remove.forEach(function (i) {
      ins(".ui_edit_class[data-uichangeclass='" + i + "']")._removeclass(
        "ins_act"
      );
    });
    r = remove;
  }

  if (e._getdata("ui_panel_option")) {
    t.editor._settings._setting_options(
      t.editor.act_object._getattr("id"),
      e._getdata("ui_panel_option"),
      e._getdata("ui_panel_option_remov")
    );
  }

  if ((this._change_class(c, r, e._getdata("toggle")), e._getdata("update"))) {
    //   e._addclass("ins_act");
  } else {
  }
};
//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="Style">

InsEditorObject.prototype._change_css = function (
  name,
  value,
  toggel = null,
  update = false,
  t = null
) {
  var status = true;
  var c = this.editor._object._get();

  if (ins(toggel)._is_exists()) {
    if (c._getcss(name) === value) {
      c._removecss(name);
      status = false;
    } else {
      c._css(name, value);
      status = true;
    }
  } else {
    c._css(name, value);
  }

  t.editor._settings._update_one("pstyle", c._getattr("style"), update);
  return status;
};

InsEditorObject.prototype._ui_edit_css = function (e, t) {
  var act_obj = t.editor.act_object;
  function css_opa(e, opa = "plus", n = "") {
    var v = "";
    if (n === "") {
      n = act_obj._getcss(e._getdata("name"));
    }
    if (!ins(n)._is_empty()) {
      n = n.replace(/[^0-9-.]/g, "");
    } else {
      n = 0;
    }
    if (opa === "minus") {
      v += parseFloat(n) - parseFloat(e._getdata("minus"));
    } else {
      v += parseFloat(n) + parseFloat(e._getdata("plus"));
    }
    return v;
  }

  var v = "";
  var thisattar = "";

  var value = e._getdata("value");

  var name = e._getdata("name");
  var addbeforvalue = e._getdata("addbeforvalue");
  var addbeforvalue = e._getdata("addbeforvalue");
  var addtovalue = e._getdata("addtovalue");
  //var sub_css = e._getdata("sub_css");

  if (e._hasclass("sub_css")) {
    var n = act_obj._getcss(name);
    if (!ins(n)._is_empty()) {
      n.split(" ").forEach(function (i) {
        var bf = addbeforvalue.replace("(", "");
        if (i.search(bf) === -1) {
          v += " " + i + " ";
        } else {
          thisattar = i;
        }
      });
    }
  }

  if (ins(addbeforvalue)._is_exists()) {
    v += addbeforvalue;
  }
  if (ins(value)._is_exists()) {
    v += value;
  } else if (ins(e._getdata("plus"))._is_exists()) {
    v += css_opa(e, "plus", thisattar);
  } else if (ins(e._getdata("minus"))._is_exists()) {
    v += css_opa(e, "minus", thisattar);
  } else {
    v += e._getvalue();
  }
  if (ins(e._getdata("valuem"))._is_exists()) {
    v /= parseFloat(e._getdata("valuem"));
  }

  if (ins(addtovalue)._is_exists()) {
    v += addtovalue;
  }

  if (e._getdata("ui_panel_option")) {
    t.editor._settings._setting_options(
      act_obj._getattr("id"),
      e._getdata("ui_panel_option"),
      e._getdata("ui_panel_option_remov")
    );
  }

  if (t._change_css(name, v, e._getdata("toggle"), false, t)) {
    ins(".ui_edit_css[data-name=" + name + "]")._removeclass("ins_act");
    if (e._hasclass("e_click")) {
      e._addclass("ins_act");
    }
  } else {
    e._removeclass("ins_act");
  }
};

InsEditorObject.prototype._style_paste = function (obj, t) {
  obj._setattr("style", this.editor._data._clipboard["style"]);
  t.editor._settings._update_one(
    "pstyle",
    this.editor._data._clipboard["style"],
    true,
    obj._getattr("id")
  );
  this.editor._ui._send_info(this.editor._t._msg.clipboard_Format_update);
};

InsEditorObject.prototype._style_copy = function (obj, t) {
  var st = t.editor._settings._get(obj._getattr("id"));

  this.editor._data._clipboard["style"] = st["settings"].pstyle;

  this.editor._ui._send_info(this.editor._t._msg.clipboard_Format_copied);
};

InsEditorObject.prototype._ui_edit_style = function (e, t) {
  var act_obj = t.editor.act_object;

  var style = {};

  if (
    (act_obj._hasclass(t.editor._classes.ui_class_ui_fixed) ||
      act_obj._hasclass("ui_absolute")) &&
    ins(e._getdata("style_fixed"))._is_exists()
  ) {
    style = JSON.parse(e._getdata("style_fixed"));
  } else {
    style = JSON.parse(e._getdata("style"));
  }

  if (ins(style["transform"])._is_exists()) {
    var s = style["transform"];
    s = s.split("(");

    style["transform"] = t.editor._object._get_transform(s[0], "(" + s[1]);
  }

  act_obj._css(style);
  t.editor._settings._update_one("pstyle", act_obj._getattr("style"), true);

  if (e._getdata("ui_panel_option")) {
    t.editor._settings._setting_options(
      act_obj._getattr("id"),
      e._getdata("ui_panel_option"),
      e._getdata("ui_panel_option_remov")
    );
  }
};

InsEditorObject.prototype._get_transform_value = function (
  name,
  remove,
  defult,
  c = null
) {
  if (c === null) {
    c = this.editor._object._get();
  }
  r = "";
  c._getcss("transform")
    .split(" ")
    .forEach(function (it) {
      var i = it.split("(");
      if (i[0].trim() === name) {
        r = i[1].trim();
        r = r.replace(")", "");
        if (ins(remove)._is_exists()) {
          remove.forEach(function (i) {
            r = ins(r)._data._replaceAll(i, "");
          });
        }
      }
    });

  if (r === "" && defult !== null) {
    r = defult;
  }
  return r;
};

InsEditorObject.prototype._get_transform = function (name, value, c = null) {
  if (c === null) {
    c = this.editor._object._get();
  }
  var r = "";
  var d = false;
  c._getcss("transform")
    .split(" ")
    .forEach(function (it) {
      var i = it.split("(");

      if (i[0].trim() === name) {
        d = true;
        r += " " + name + value;
      } else {
        r += it + " ";
      }
    });
  if (r.trim() === "" || !d) {
    r += " " + name + value;
  }

  return r;
};

//</editor-fold>

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="anchors">

InsEditorObject.prototype._remove_anchors = function () {
  ins(".ui_anchor")._remove();
};

InsEditorObject.prototype._add_anchor_old = function (
  parent,
  x,
  y,
  fun,
  xonly = false,
  yonly = false,
  same = false
) {
  var container = parent
    ._append(
      '<span class="ui_anchor"  style="text-align: center;color:#fff; cursor: pointer; position: fixed;top:' +
        (parseFloat(y) - 4) +
        "px;left:" +
        (parseFloat(x) - 4) +
        'px; width:10px; height:10px;     border-radius: 50%; background:#1a73e8;"><span>'
    )
    ._get(0);
  var offset = [0, 0];
  var isDown = false;

  container.addEventListener(
    "mousedown",
    function (e) {
      isDown = true;
      offset = [
        container.offsetLeft - e.clientX,
        container.offsetTop - e.clientY,
      ];
    },
    true
  );

  container.addEventListener(
    "mouseup",
    function () {
      isDown = false;
    },
    true
  );

  document.addEventListener(
    "mouseup",
    function () {
      isDown = false;
    },
    true
  );

  document.addEventListener(
    "mousemove",
    function (e) {
      if (isDown) {
        if (!xonly) {
          if (same) {
            container.style.top = e.clientX + offset[0] + "px";
          } else {
            container.style.top = e.clientY + offset[1] + "px";
          }
        }
        if (!yonly) {
          container.style.left = e.clientX + offset[0] + "px";
        }

        fun(e.clientX + offset[0], e.clientY + offset[1]);
      }
    },
    true
  );

  return container;
};

/**
 *
 * @param {type} o
 *  {parent : , obj : null , left :0, top:0,  move_y_only:false,  move_x_only:false, y_sam_x:false,  move_x_only:false}
 * @returns {ui_action_add_anchor_point.container}
 */
InsEditorObject.prototype._add_anchor = function (o) {
  var data = "";
  if (!ins(o.data)._is_empty()) {
    data = o.data;
  }

  var container = o.parent
    ._append(
      '<span  class="ui_anchor"  style=" font-size: 10px;     border: 1px solid #fff;  box-shadow: 1px 1px 5px #0b0b0b5c; text-align: center;color:#fff; cursor: pointer; position: absolute;top:' +
        o.top +
        ";left:" +
        o.left +
        '; width:10px; height:10px;border-radius: 50%; background:#1a73e8;">' +
        data +
        "<span>"
    )
    ._get(0);

  if (!ins(o.css)._is_empty()) {
    ins(container)._css(o.css);
  }

  var offset = [0, 0];
  var isDown = false;

  if (o.obj === null) {
    o.obj = container;
  }

  container.addEventListener(
    "mousedown",
    function (e) {
      isDown = true;
      if (!ins(o.onstrat)._is_empty()) {
        o.onstrat(e.clientX + offset[0], e.clientY + offset[1], e);
      }
      offset = [o.obj.offsetLeft - e.clientX, o.obj.offsetTop - e.clientY];
    },
    true
  );

  /*
     container.addEventListener('mouseup', function () {
     isDown = false;
     }, true);*/

  document.addEventListener(
    "mouseup",
    function (e) {
      isDown = false;

      if (!ins(o.onend)._is_empty()) {
        o.onend(e.clientX + offset[0], e.clientY + offset[1], e);
      }
    },
    true
  );

  if (ins(o.obj)._is_empty()) {
    o.obj = container;
  }
  if (ins(o.move_x_only)._is_empty()) {
    o.move_x_only = false;
  }
  if (ins(o.move_y_only)._is_empty()) {
    o.move_y_only = false;
  }

  if (ins(o.y_sam_x)._is_empty()) {
    o.y_sam_x = false;
  }

  document.addEventListener(
    "mousemove",
    function (e) {
      if (isDown) {
        if (!o.move_x_only) {
          if (o.y_sam_x) {
            o.obj.style.top = e.clientX + offset[0] + "px";
          } else {
            o.obj.style.top = e.clientY + offset[1] + "px";
          }
        }
        if (!o.move_y_only) {
          o.obj.style.left = e.clientX + offset[0] + "px";
        }

        if (!ins(o.onchange)._is_empty()) {
          o.onchange(e.clientX + offset[0], e.clientY + offset[1], e);
        }
      }
    },
    true
  );

  return container;
};

InsEditorObject.prototype._lock_unlock = function (p = null) {
  p = this._get(p);
  var t = this;

  if (p._hasclass("ui_fixed")) {
    p._removeclass("ins_act_fixed", "ui_fixed");
    p._removecss("width");
    p._removecss("height");
    p._removecss("transform");
    p._removecss("left");
    p._removecss("top");
    t._active(p);

    t.editor._settings._update_one("pstyle", p._getattr("style"));
  } else {
    p._addclass("ins_act_fixed");
    t._unlock();
    t.editor.act_object._addclass("ui_fixed");
  }

  t._update_settings_classes();
};

InsEditorObject.prototype._unlock = function () {
  var t = this;
  var act_obj = t._get();

  var left = act_obj._p("offsetLeft");
  var top = act_obj._p("offsetTop");
  var height = act_obj._p("clientHeight");
  var width = act_obj._p("clientWidth");
  var tmpwidth = 0;
  var tempheight = 0;

  function _onend() {
    t.editor._settings._update_one("pstyle", act_obj._getattr("style"));
    t.editor.ui_object_act_disabled = true;
  }

  function _onstart() {
    t.editor.ui_object_act_disabled = true;
  }

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "50%",
    top: "-35px",
    css: {
      width: "25px",
      height: "25px",
      cursor: "move",
      "line-height": "25px",
      transform: "translateX(-50%)  rotate(45deg)",
      background: "rgb(232, 151, 26)",
      cursor: "move",
    },
    data: '<i class="fas fa-expand-arrows-alt"></i>',
    onstrat: _onstart(),
    onend: _onend(),
    onchange: (x, y) => {
      ins(".ui_anchor_top")._setvalue(y);
      ins(".ui_anchor_left")._setvalue(x);
    },
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "-25px",
    top: "-25px",

    css: {
      width: "25px",
      height: "25px",
      cursor: "move",
      "line-height": "25px",
      transform: "translateX(-50%) ",
      background: "rgb(232, 151, 26)",
    },

    data: '<i class="fas fa-sync-alt"></i>',
    onstrat: (x, y, e) => {
      left = act_obj._p("offsetLeft");
      top = act_obj._p("offsetTop");

      midpoint = {
        x: act_obj._p("offsetLeft") + act_obj._p("clientWidth") / 2 - 2,
        y: act_obj._p("offsetTop") + act_obj._p("clientHeight") / 2 - 2,
      };
      startpoint = { x: e.offsetX, y: e.offsetY };

      angle = parseFloat(t._get_transform_value("rotate", ["deg"], 0));

      t.editor.ui_object_act_disabled = true;
    },
    onend: _onend(),
    onchange: (x, y, e) => {
      var sp = startpoint,
        mp = midpoint;

      var p = { x: e.offsetX, y: e.offsetY };
      var sAngle = Math.atan2(sp.y - mp.y, sp.x - mp.x);
      var pAngle = Math.atan2(p.y - mp.y, p.x - mp.x);
      var m = ((pAngle - sAngle) * 180) / Math.PI;

      if (m > 40) {
        m = 1;
      }
      if (m < -10) {
        m = -1;
      }
      angle += m;
      var tr = t._get_transform("rotate", "(" + angle + "deg)");
      act_obj._css({
        transform: tr,
        top: top + "px",
        left: left + "px",
      });
      ins(".ui_anchor_rotate")._setvalue(angle);
      startpoint = { x: p.x, y: p.y };
    },
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "100%",
    top: "50%",
    css: { transform: "translate(-50%, -50%)", cursor: "e-resize" },
    move_x_only: true,
    onend: () => {
      t.editor._settings._update_one("pstyle", act_obj._getattr("style"));
    },
    onstrat: (x, y) => {
      tmpwidth = width;
      left = act_obj._p("offsetLeft");
    },
    onchange: (x, y) => {
      var o = left - x;
      width = parseFloat(tmpwidth) - o;
      ins(".ui_anchor_width")._setvalue(width);
      act_obj._css({
        width: width + "px",
        left: left + "px",
      });
    },
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "0",
    top: "50%",
    onend: _onend(),
    css: { transform: "translate(-50%, -50%)", cursor: "e-resize" },

    move_x_only: true,
    onstrat: (x, y) => {
      tmpwidth = act_obj._p("clientWidth");
      left = act_obj._p("offsetLeft");
    },
    onchange: (x, y) => {
      var o = left - x;
      width = parseFloat(tmpwidth) + o;
      ins(".ui_anchor_width")._setvalue(width);

      act_obj._css({
        width: width + "px",
      });
    },
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "50%",
    top: "0",
    css: { transform: "translate(-50%, -50%)", cursor: "s-resize" },
    move_y_only: true,
    onstrat: (x, y) => {
      tmpwidth = act_obj._p("clientHeight");
      top = act_obj._p("offsetTop");
    },
    onchange: (x, y) => {
      height = parseFloat(tmpwidth) + (top - y);
      ins(".ui_anchor_height")._setvalue(height);

      act_obj._css({
        height: height + "px",
      });
    },
    onend: _onend(),
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "50%",
    top: "100%",
    css: { transform: "translate(-50%, -50%)", cursor: "s-resize" },
    move_y_only: true,
    onstrat: (x, y) => {
      tempheight = act_obj._p("clientHeight");
      top = act_obj._p("offsetTop");
    },
    onchange: (x, y) => {
      height = parseFloat(tempheight) - (top - y);
      ins(".ui_anchor_height")._setvalue(height);
      act_obj._css({
        height: height + "px",
        top: top + "px",
      });
    },
    onend: _onend(),
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "100%",
    top: "100%",
    css: { transform: "translate(-50%, -50%)", cursor: "nw-resize" },
    move_y_only: true,
    onstrat: (x, y) => {
      top = act_obj._p("offsetTop");
      left = act_obj._p("offsetLeft");

      tmpwidth = act_obj._p("clientWidth");
      tempheight = act_obj._p("clientHeight");
    },
    onchange: (x, y) => {
      height = parseFloat(tempheight) - (top - y);
      width = parseFloat(tmpwidth) - (left - x);

      ins(".ui_anchor_height")._setvalue(height);
      ins(".ui_anchor_width")._setvalue(width);

      act_obj._css({
        width: width + "px",
        height: height + "px",
        top: top + "px",
      });
    },
    onend: _onend(),
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "0",
    top: "100%",
    css: { transform: "translate(-50%, -50%)", cursor: "nesw-resize" },
    onstrat: (x, y) => {
      top = act_obj._p("offsetTop");
      left = act_obj._p("offsetLeft");

      tmpwidth = act_obj._p("clientWidth");
      tempheight = act_obj._p("clientHeight");
    },
    onchange: (x, y) => {
      height = parseFloat(tempheight) - (top - y);
      width = parseFloat(tmpwidth) + (left - x);
      ins(".ui_anchor_height")._setvalue(height);
      ins(".ui_anchor_width")._setvalue(width);
      act_obj._css({
        width: width + "px",
        height: height + "px",
        top: top + "px",
      });
    },
    onend: _onend(),
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "0",
    top: "0",
    css: { transform: "translate(-50%, -50%)", cursor: "nw-resize" },

    onstrat: (x, y) => {
      top = act_obj._p("offsetTop");
      left = act_obj._p("offsetLeft");

      tmpwidth = act_obj._p("clientWidth");
      tempheight = act_obj._p("clientHeight");
    },
    onchange: (x, y) => {
      height = parseFloat(tempheight) + (top - y);
      width = parseFloat(tmpwidth) + (left - x);
      ins(".ui_anchor_height")._setvalue(height);
      ins(".ui_anchor_width")._setvalue(width);
      act_obj._css({
        width: width + "px",
        height: height + "px",
      });
    },
    onend: _onend(),
  });

  t._add_anchor({
    parent: act_obj,
    obj: ins(act_obj)._get(0),
    left: "100%",
    top: "0",
    move_y_only: true,
    css: { transform: "translate(-50%, -50%)", cursor: "nesw-resize" },
    onstrat: (x, y) => {
      top = act_obj._p("offsetTop");
      left = act_obj._p("offsetLeft");
      tmpwidth = act_obj._p("clientWidth");
      tempheight = act_obj._p("clientHeight");
    },
    onchange: (x, y) => {
      height = parseFloat(tempheight) + (top - y);
      width = parseFloat(tmpwidth) - (left - x);
      ins(".ui_anchor_height")._setvalue(height);
      ins(".ui_anchor_width")._setvalue(width);
      act_obj._css({
        width: width + "px",
        height: height + "px",
        left: left + "px",
      });
    },
    onend: _onend(),
  });
};

ins(".ui_action_update_line")._toggle(
  function (o) {
    ui_object_act_disabled = true;
    o._addclass("ins_act");
    ui_action_update_line();
  },
  function (o) {
    o._removeclass("ins_act");
    ui_action_remove_anchors();
    ui_object_act_disabled = false;
    ui_obj_update(act_obj);
  }
);

InsEditorObject.prototype.ui_action_update_line = function () {
  var t = this;
  var act_obj = t.editor.act_object;
  var id = act_obj._getattr("id");
  var settings = ui_settings_get(id);
  if (settings.settings.type == "svg" && settings.settings.svg == "line") {
    if (
      !ins(settings.settings.x1)._is_empty() &&
      !ins(settings.settings.y1)._is_empty()
    ) {
      var p1 = t._add_anchor_old(
        act_obj,
        settings.settings.x1,
        settings.settings.y1,
        function (x, y) {
          act_obj._find("line")._setattr("x1", x);
          act_obj._find("line")._setattr("y1", y);

          t.editor._settings._update_one("x1", x);
          t.editor._settings._update_one("y1", y);

          if (parseFloat(p2.offsetTop) < parseFloat(y)) {
            act_obj._find("svg")._setattr("height", parseFloat(y));
          }

          if (parseFloat(p2.offsetLeft) < parseFloat(x)) {
            act_obj._find("svg")._setattr("width", parseFloat(x));
          }
        }
      );
    }
    if (
      !ins(settings.settings.x2)._is_empty() &&
      !ins(settings.settings.y2)._is_empty()
    ) {
      var p2 = ui_action_add_anchor(
        act_obj,
        settings.settings.x2,
        settings.settings.y2,
        function (x, y) {
          act_obj._find("line")._setattr("x2", x);
          act_obj._find("line")._setattr("y2", y);

          t.editor._settings._update_one("x2", x);
          t.editor._settings._update_one("y2", y);

          if (parseFloat(p1.offsetTop) < parseFloat(y)) {
            act_obj._find("svg")._setattr("height", parseFloat(y));
          }

          if (parseFloat(p1.offsetLeft) < parseFloat(x)) {
            act_obj._find("svg")._setattr("width", parseFloat(x));
          }
        }
      );
    }
  } else if (
    settings.settings.type == "svg" &&
    settings.settings.svg == "rect"
  ) {
    if (!ins(settings.settings.width)._is_empty()) {
      var h_an = t._add_anchor_old(
        act_obj,
        parseFloat(settings.settings.width) + 8,
        parseFloat(settings.settings.height) / 2,
        function (x, y) {
          act_obj._find("svg")._setattr("width", parseFloat(x));
          act_obj._find("rect")._setattr("width", parseFloat(x) - 8);

          w_an.style.left = x / 2 + "px";

          t.editor._settings._update_one("width", x);
        },
        true
      );
    }
    if (!ins(settings.settings.height)._is_empty()) {
      var w_an = t._add_anchor_old(
        act_obj,
        parseFloat(settings.settings.width) / 2,
        parseFloat(settings.settings.height) + 8,
        function (x, y) {
          act_obj._find("svg")._setattr("height", parseFloat(y));
          act_obj._find("rect")._setattr("height", parseFloat(y) - 8);

          t.editor._settings._update_one("height", y);
          h_an.style.top = y / 2 + "px";
        },
        false,
        true
      );
    }
  } else if (
    settings.settings.type == "svg" &&
    settings.settings.svg == "ellipse"
  ) {
    if (!ins(settings.settings.width)._is_empty()) {
      var h_an = t._add_anchor_old(
        act_obj,
        parseFloat(settings.settings.width) + 8,
        parseFloat(settings.settings.height) / 2,
        function (x, y) {
          act_obj._find("svg")._setattr("width", parseFloat(x));
          var r = parseFloat(x) / 2;
          act_obj._find("ellipse")._setattr("cx", r);
          act_obj._find("ellipse")._setattr("rx", r - 8);
          w_an.style.left = x / 2 + "px";

          t.editor._settings._update_one("cx", r);
          t.editor._settings._update_one("rx", r - 8);
          t.editor._settings._update_one("width", x);
        },
        true
      );
    }
    if (!ins(settings.settings.height)._is_empty()) {
      var w_an = t._add_anchor_old(
        act_obj,
        parseFloat(settings.settings.width) / 2,
        parseFloat(settings.settings.height) + 8,
        function (x, y) {
          var r = parseFloat(y) / 2;
          act_obj._find("svg")._setattr("height", parseFloat(y));
          act_obj._find("ellipse")._setattr("cy", r);
          act_obj._find("ellipse")._setattr("ry", r - 8);

          t.editor._settings._update_one("cy", r);
          t.editor._settings._update_one("ry", r - 8);
          t.editor._settings._update_one("height", x);

          h_an.style.top = y / 2 + "px";
        },
        false,
        true
      );
    }
  } else if (
    settings.settings.type == "svg" &&
    settings.settings.svg == "circle"
  ) {
    if (!ins(settings.settings.r)._is_empty()) {
      var h_an = t._add_anchor_old(
        act_obj,
        parseFloat(settings.settings.r) * 2,
        parseFloat(settings.settings.r) * 2,
        function (x, y) {
          var r = parseFloat(x) / 2;
          act_obj._find("circle")._setattr("r", r - 10);
          act_obj._find("circle")._setattr("cy", r + 5);
          act_obj._find("circle")._setattr("cx", r + 5);
          act_obj._find("svg")._setattr("width", parseFloat(x) + 10);
          act_obj._find("svg")._setattr("height", parseFloat(x) + 10);

          t.editor._settings._update_one("height", parseFloat(x) + 10);
          t.editor._settings._update_one("width", parseFloat(x) + 10);

          t.editor._settings._update_one("cy", r + 5);
          t.editor._settings._update_one("cx", r + 5);
          t.editor._settings._update_one("r", r - 10);
        },
        false,
        false,
        true
      );
    }
  }
};

//</editor-fold>

/*
 
 var ui_editor_update = (e) => {
 var options = e._getdata();
 options.value = e._getvalue();
 
 aj(options, function (data) {
 });
 
 };
 
 ins(".ui_editor_update.e_click")._on("click", ui_editor_update, true);
 ins(".ui_editor_update.e_input")._on("input", ui_editor_update, true);
 ins(".ui_editor_update.e_change")._on("change", ui_editor_update, true);
 
 
 ins(".ui_background_path")._on("click", function (o) {
 ins(".ui_background_panel")._setattr("src", o._getdata("src"));
 }, true);
 */

/**
 *
 * @param {type} o
 * @param {ins_ui_editor} t
 * @returns {undefined}
 */

InsEditorObject.prototype._copy = function (o = null, t = null) {
  var t = this;
  o = t._get(o);

  function update_ids(thisid, obj, p) {
    p._setattr("id", thisid);
    obj.settings["id"] = thisid;

    if (ins(obj.settings.data)._is_exists()) {
      Object.keys(obj.settings.data).forEach(function (key) {
        if (
          typeof obj.settings.data[key] !== "string" &&
          !ins(obj.settings.data[key])._is_empty()
        ) {
          var id = ins()._data._get_unique_id();

          var j = update_ids(id, obj.settings.data[key], p._find("#" + key));

          delete obj.settings.data[key];
          obj.settings.data[id] = j;
        }
      });
    }

    return obj;
  }

  function jsonCopy(src) {
    return JSON.parse(JSON.stringify(src));
  }

  //t._object._get_settings()

  var st = jsonCopy(t.editor._settings._get(o._getattr("id")));

  var c = o._clone();
  var id = ins()._data._get_unique_id();

  st = update_ids(id, st, c);

  if (ins(".ui_editor_view")._get(0) === o._parent()._get(0)) {
    t.editor._settings._update(id, st);
  } else {
    var pid = o
      ._parents("." + t.editor._classes.editor_block_container)
      ._getattr("id");
    t.editor._settings._update_one("data", st, false, pid, id);
  }

  o._append_after(c);
  t._active(o);
  t.editor._settings._code_update();
};

//<editor-fold defaultstate="collapsed" desc="ui_edit_setting">
/*function update_psettings(p, name, value) {
 var j = p._find(".ui_editor_block_setting")._getdata("settings");
 var j = JSON.parse(j);
 j[name] = value;
 p._find(".ui_editor_block_setting")._setdata("settings", JSON.stringify(j));
 }*/
/*
 function get_settings(name = null, obj = null) {
 
 if (obj === null) {
 obj = act_obj;
 }
 if (name === null) {
 return   ui_settings_get(act_obj._getattr("id"));
 } else {
 var j = ui_settings_get(act_obj._getattr("id"));
 return j[name];
 }
 }*/

InsEditorObject.prototype.update_block_css = function (obj = null) {
  var settings = this.editor._object._get_settings("settings", obj);
  obj._setattr("style", settings["pstyle"]);
};
/*
 InsEditorObject.prototype.update_block_classes = function (obj = null) {
 
 var settings = this._object._get_settings("settings", obj);
 
 var classtype = " " + settings["pclass"]
 
 if (obj._getdata("append") == "inner") {
 classtype += " " + this.editor._classes.editor_block_object + "  " + this.editor._classes.editor_block_container;
 } else {
 classtype += " " + this.editor._classes.editor_block_object + "  " + this.editor._classes.editor_block_data;
 
 }
 
 obj._setattr("class", "ui_editor_block  " + classtype);
 
 //   ui_setting_update(act_obj._getattr("id"), name, value, update);
 
 this.editor._settings._update_one(act_obj._getattr("id"), name, value, update);
 };*/

/*
 function update_block_code() {
 ins(".ui_edit_setting")._each(ui_edit_setting);
 }*/

//</editor-fold>

/**
 *
 * @param {type} o
 * @param {type} e
 * @param {InsEditorObject} t
 * @returns {undefined}
 */
InsEditorObject.prototype.drop = function (o, e, oo, editor) {
  let p, c;
  var t = this;
  editor._history_add({
    obj: "",
    type: "drop",
    settings: t.editor._settings._console_get_code(),
    update: false,
  });

  if (t.innerdrag) {
    c = ins("." + t.actclass)._get(0);
  } else {
    c = ins(ins("." + t.actclass)._get(0))._clone();
    if (ins(c._find("img"))._is_exists()) {
      c._find("img")._remove();
    }
  }

  if (ins(c)._is_exists()) {
    if (t.appendPosition === "left") {
      p = o._append_befor(c);
    } else if (t.appendPosition === "right") {
      p = o._append_after(c);
    } else {
      p = o._append(c);
    }

    if (p._hasclass(editor._classes.editor_block_list)) {
      var id = ins()._data._get_unique_id();
      var st = JSON.parse(p._getdata("settings"));
      st.settings["id"] = id;

      var classtype = " " + st["settings"].pclass;

      if (p._getdata("append") == "inner") {
        classtype +=
          " " +
          editor._classes.editor_block_container +
          "   " +
          editor._classes.editor_block_object;
      } else {
        classtype +=
          " " +
          editor._classes.editor_block_data +
          "   " +
          editor._classes.editor_block_object;
      }

      p._removeclass(editor._classes.editor_block_list);
      p._removeattr("data-settings");

      var tp = "ui_object_type_" + st.type;

      p._setattr("id", id);
      p._setattr("class", " ui_editor_block  " + tp + " " + classtype);
      if (!ins(st.settings.pstyle)._is_empty()) {
        p._setattr("style", st.settings.pstyle);
      }

      if (p._is_exists()) {
        if (!ins(p._find(".ui_preview_item"))._is_empty()) {
          p._find(".ui_preview_item")._remove();
        }
      }
    } else {
      var id = p._getattr("id");
      var st = editor._settings._get(p._getattr("id"));
      editor._settings._remove(p._getattr("id"));
    }

    p._removeattr("draggable");

    t._set(p);

    if (ins(".ui_editor_view")._get(0) === p._parent()._get(0)) {
      editor._settings._update(id, st);
    } else {
      var pid = p
        ._parents("." + editor._classes.editor_block_container)
        ._getattr("id");
      editor._settings._update_one("data", st, false, pid, id);
    }

    t._active(p);

    editor._ui._setting_update_panel();

    editor._ui._update_panel(
      ins(".ui_editor_items_panel .header li")._index(1)
    );

    ins("." + t.actclass)._css({ opacity: "1" });
    ins("." + t.actclass)._removeclass(t.actclass);

    ins(".ui_editor_block")._removeclass(
      "item_draging_hover",
      "ins_left_position",
      "ins_inner_position",
      "ins_right_position"
    );
    ins(".ui_editor_view")._removeclass(
      "item_draging_hover",
      "ins_left_position",
      "ins_inner_position",
      "ins_right_position"
    );
    editor._settings._code_update();
    t._update(p);

    editor._ui._get_toolbar();

    e.preventDefault();
    e.stopPropagation();
  }
};

//</editor-fold>

//<editor-fold defaultstate="collapsed" desc="Main">

function ins_ui_editor() {
  var t = this;

  this.act_object = "";

  this._options = { history_limit: 20 };

  this._data = {
    ui_history: [],
    ui_history_redo: [],
    _setting: [],
    _clipboard: [],
  };

  this._classes = {
    editor_block: "ui_editor_block",
    editor_block_list: "ins_grid_object",
    editor_block_object: "ui_object",
    editor_block_container: "container_data",
    editor_block_data: "view_data",
    editor_block_act: "ui_block_act",
    ui_class_ui_fixed: "ui_fixed",
  };

  this._keys = {
    _f8: 119,
    _f9: 120,
    _f10: 121,
  };

  this.editor_object = ins(".ui_editor_view");
  this.ui_editor_view_input = "";
  this._settings = new InsEditorSettings(this);
  this._ui = new InsEditorUI(this);
  this._t = new InsEditorT(this);
  this._object = new InsEditorObject(this);

  //<editor-fold defaultstate="collapsed" desc="ُevents">

  ins(".ui_editor_save.e_click")._on(
    "click",
    function (e) {
      t._save(e);
    },
    true
  );

  ins(".ui_editor_save.e_input")._on(
    "input",
    function (e) {
      t._save(e);
    },
    true
  );
  ins(".ui_editor_save.e_change")._on(
    "change",
    function (e) {
      t._save(e);
    },
    true
  );

  ins(".ui_editor_style_grid,.ui_editor_style_grid i")._on(
    "click",
    function (e) {
      t._show_hide_grid(e);
    },
    true
  );

  ins(".ui_editor_zoom.e_click")._on(
    "click",
    function (e) {
      t._zoom(e);
    },
    true
  );
  ins(".ui_editor_zoom.e_input")._on("input", function (e) {
    t._zoom(e);
  });

  ins(".ui_text_preview")._on("click", function () {}, true);

  ins(".ui_editor_redo")._on(
    "click",
    function () {
      t._history_redo();
    },
    true
  );

  ins(".ui_editor_info")._on(
    "click",
    function () {
      if (ins(".ui_editor")._hasclass("_show_info")) {
        ins(".ui_editor")._removeclass("_show_info");
      } else {
        ins(".ui_editor")._addclass("_show_info");
      }
    },
    true
  );

  ins(".ui_editor_undo")._on(
    "click",
    function (e) {
      t._history_undo();
    },
    true
  );

  //<editor-fold defaultstate="collapsed" desc="ui_console_area">

  /*
     
     
     ins(".ui_console_to_left")._on("click", function (e) {
     ins(".ui_console_to_right")._removeclass("ins_act");
     ins(".ui_console_to_bottom")._removeclass("ins_act");
     if (ins(".ui_editor")._hasclass("ui_console_area_open") && ins(".ui_editor")._hasclass("ui_console_area_toleft")) {
     ins(".ui_editor")._removeclass("ui_console_area_open");
     ins(".ui_editor")._addclass("ui_console_area_toleft");
     e._removeclass("ins_act");
     } else {
     ins(".ui_editor")._removeclass("ui_console_area_toright");
     ins(".ui_editor")._addclass("ui_console_area_open", "ui_console_area_toleft");
     e._addclass("ins_act");
     }
     
     }, true);
     
     ins(".ui_console_to_right")._on("click", function (e) {
     ins(".ui_console_to_left")._removeclass("ins_act");
     ins(".ui_console_to_bottom")._removeclass("ins_act");
     if (ins(".ui_editor")._hasclass("ui_console_area_open") && ins(".ui_editor")._hasclass("ui_console_area_toright")) {
     
     ins(".ui_editor")._removeclass("ui_console_area_open");
     ins(".ui_editor")._addclass("ui_console_area_toright");
     e._removeclass("ins_act");
     } else {
     e._addclass("ins_act");
     ins(".ui_editor")._removeclass("ui_console_area_toleft");
     ins(".ui_editor")._addclass("ui_console_area_open", "ui_console_area_toright");
     }
     }, true);
     
     ins(".ui_console_to_bottom")._on("click", function (e) {
     ins(".ui_console_to_left")._removeclass("ins_act");
     ins(".ui_console_to_right")._removeclass("ins_act");
     if (ins(".ui_editor")._hasclass("ui_console_area_open")) {
     ins(".ui_editor")._removeclass("ui_console_area_open", "ui_console_area_toright", "ui_console_area_toleft");
     e._removeclass("ins_act");
     } else {
     
     e._addclass("ins_act");
     ins(".ui_editor")._removeclass("ui_console_area_toright", "ui_console_area_toleft");
     ins(".ui_editor")._addclass("ui_console_area_open");
     }
     
     
     }, true);
     */

  this.ui_view_area = ins(".ui_editor_mian_area");

  this.ui_console_area = ins(".ui_console_area");
  this.ui_console_area_anchur_isDown = false;
  this.ui_console_area_width = 0;
  this.ui_console_area_height = 0;
  this.ins_editor_width = 0;
  this.ins_editor_height = 0;

  this.ui_view_area_width = 0;
  this.ui_view_area_height = 0;

  ins(".ui_console_area_anchur")._on(
    "mousedown",
    function (o, e) {
      t.ui_console_area_anchur_isDown = true;
      t.ui_console_area_width = t.ui_console_area._p("clientWidth");
      t.ui_console_area_height = t.ui_console_area._p("clientHeight");

      t.ui_view_area_width = t.ui_view_area._p("clientWidth");
      t.ui_view_area_height = t.ui_view_area._p("clientHeight");

      t.ins_editor_width = ins(".ui_editor")._p("clientWidth");
      t.ins_editor_height = ins(".ui_editor")._p("clientHeight");

      offset = [e.clientX, e.clientY];
    },
    true
  );

  ins(".ui_console_area_anchur")._on(
    "mouseup",
    function (e) {
      t.ui_console_area_anchur_isDown = false;
    },
    true
  );

  document.addEventListener("mouseup", function (e) {
    t.ui_console_area_anchur_isDown = false;
  });

  document.addEventListener(
    "mousemove",
    function (e) {
      if (t.ui_console_area_anchur_isDown) {
        t.ui_console_area._css({
          height:
            t.ui_console_area_height + (e.clientY - offset[1]) * -1 + "px",
        });
      }
    },
    true
  );

  ins(".ui_text_code_all_toggle ,.ui_text_code_all_toggle i")._on(
    "click",
    function (e) {
      if (ins(".ui_editor")._hasclass("ui_console_area_open")) {
        ins(".ui_editor")._removeclass("ui_console_area_open");
        e._removeclass("ins_act");
      } else {
        ins(".ui_editor")._addclass("ui_console_area_open");
        e._addclass("ins_act");
      }
    }
  );

  var ui_code_input =
    ".ui_editor_console_ins ,.ui_editor_console_css ,.ui_editor_console_js";

  ins("*")._on("keydown", function (o, e) {
    t._ui._send_info(t._t._msg.code_save_and_update);
    if (e.keyCode === t._keys._f8 && e.ctrlKey) {
      t._update_view();
    } else if (e.keyCode === t._keys._f9 && e.ctrlKey) {
      t._fast_save(e);
    } else if (e.keyCode === t._keys._f10 && e.ctrlKey) {
      t._save(e);
    }
  });

  //</editor-fold>

  ins(".ui_editor_show_item ,.ui_editor_show_item i")._on("click", function (
    e
  ) {
    e._parent()._find(e._p("tagName"))._removeclass("ins_act");
    e._addclass("ins_act");
    ins(e._getdata("hide"))._addclass("ins_hidden");
    ins(e._getdata("show"))._removeclass("ins_hidden");
  });

  ins(".ui_editor_text_code_all ,.ui_editor_text_code_all i")._on(
    "click",
    function () {
      t._settings._code_update();
    }
  );
  ins(".ui_editor_update_all_view ,.ui_editor_update_all_view i")._on(
    "click",
    function () {
      t._update_view();
    }
  );

  //</editor-fold>
}

//<editor-fold defaultstate="collapsed" desc="Editor">
ins_ui_editor.prototype._onstrat = function () {
  var t = this;
  this.ui_editor_view_input = "." + ins(".ui_editor_view")._getdata("for");
  this._settings._update();

  //<editor-fold defaultstate="collapsed" desc="Panel">

  this._ui._update_panel(ins(".ui_editor_items_panel .header li")._index(0));

  this._ajax(
    { status: "update_items", subcategory: "Input", category: "UI" },
    function (data) {
      ins(".ui_editor_items_panel  .ui_editor_items_data")._sethtml(data);
      t._update_view();
    },
    ".ui_editor_items_panel"
  );
  //</editor-fold>

  var small_g_s = 16;
  var g_s = 64;
  var h =
    '<svg width="100%" class="ui_editor_grid ins_hidden" height="100%" xmlns="http://www.w3.org/2000/svg"> <defs>\n\
<pattern id="smallGrid" width="' +
    small_g_s +
    '" height="' +
    small_g_s +
    '" patternUnits="userSpaceOnUse">\n\
<path d="M ' +
    small_g_s +
    " 0 L 0 0 0 " +
    small_g_s +
    '" fill="none" stroke="gray" stroke-width="0.5"/> \n\
</pattern><pattern id="grid" width="' +
    g_s +
    '" height="' +
    g_s +
    '" patternUnits="userSpaceOnUse"><rect width="' +
    g_s +
    '" height="' +
    g_s +
    '" fill="url(#smallGrid)"/>\n\
<path d="M ' +
    g_s +
    " 0 L 0 0 0 " +
    g_s +
    '" fill="none" stroke="gray" stroke-width="1"/>\n\
</pattern></defs><rect width="100%" height="100%" fill="url(#grid)" />\n\
</svg>';
  ins(".ui_editor_mian_area")._append(h);
  ins("." + t._classes.editor_block_act)._removeclass(
    "" + t._classes.editor_block_act
  );

  ins(".ui_editor_view .ui_editor_block")._on("dragstart", function (o, e) {
    if (!t.ui_object_act_disabled) {
      o._addclass(t._object.actclass);
      o._css({ opacity: "0.1" });
      // t.innerdrag = true;
      ins(".ui_editor_view")._addclass("ui_drag_mode");
    }
  });

  ins(".ui_editor_block." + t._classes.editor_block_list)._on(
    "dragstart",
    function (o, e) {
      if (!t.ui_object_act_disabled) {
        o._addclass(t._object.actclass);
        o._css({ opacity: "0.1" });
        //t.innerdrag = false;

        ins(".ui_editor_view")._addclass("ui_drag_mode");
      }
    }
  );

  ins(".ui_editor_view")._on("drop", function (o, e) {
    if (!t.ui_object_act_disabled) {
      e.preventDefault();
      t._object.appendPosition = "inner";
      t._object.drop(o, e, o._getdata("append"), t);
    }
  });

  ins(".ui_editor_block.view_data")._on("drop", function (o, e) {
    if (!t.ui_object_act_disabled) {
      t._object.appendPosition = "left";
      var rect = o._get(0).getBoundingClientRect();
      var o_end = rect.left + rect.width;
      if (o_end > e.x && o_end - rect.width / 4 < e.x) {
        t._object.appendPosition = "right";
      }
      t._object.drop(o, e, null, t);
    }
  });

  ins(".ui_editor_block." + t._classes.editor_block_container)._on(
    "drop",
    function (o, e) {
      if (!t.ui_object_act_disabled) {
        t._object.appendPosition = "inner";
        var rect = o._get(0).getBoundingClientRect();
        var o_end = rect.left + rect.width;
        if (rect.left < e.x && rect.left + rect.width / 4 > e.x) {
          t._object.appendPosition = "left";
        } else if (o_end > e.x && o_end - rect.width / 4 < e.x) {
          t._object.appendPosition = "right";
        } else if (o._getdata("append") === "inner") {
          o = o
            ._getchild_byclass("ui_preview")
            ._getchild_byclass("ui_type_container");
        }
        t._object.drop(o, e, null, t);
      }
    }
  );

  ins(".ui_editor_block")._on("dragend", function (o, e) {
    if (!t.ui_object_act_disabled) {
      ins(".ui_editor_block")._removeclass(
        "item_draging_hover",
        "ui_ins_drop_parent",
        "ui_drag_mode"
      );

      ins(".ui_editor_view")._removeclass("ui_drag_mode");

      ins(".ui_editor_block")._css({ opacity: "1" });
      ins("." + t.actclass)._removeclass(t.actclass);
      o._css({ opacity: "1" });
    }
  });

  ins(".ui_editor_view")._on("dragover", function (o, e) {
    if (!t.ui_object_act_disabled) {
      e.preventDefault();

      ins(".ui_editor_block")._removeclass(
        "item_draging_hover",
        "ins_left_position",
        "ins_inner_position",
        "ins_right_position",
        "ui_ins_drop_parent"
      );
      ins(".ui_editor_view")._removeclass(
        "item_draging_hover",
        "ins_left_position",
        "ins_inner_position",
        "ins_right_position",
        "ui_ins_drop_parent"
      );
      o._addclass("item_draging_hover", "ins_inner_position");
    }
  });

  ins(
    ".ui_editor_block.view_data,.ui_editor_block." +
      t._classes.editor_block_container
  )._on("dragover", function (o, e) {
    e.preventDefault();
    if (!t.ui_object_act_disabled) {
      var rect = o._get(0).getBoundingClientRect();
      ins(".ui_editor_block")._removeclass(
        "item_draging_hover",
        "ins_left_position",
        "ins_inner_position",
        "ins_right_position",
        "ui_ins_drop_parent"
      );
      ins(".ui_editor_view")._removeclass(
        "item_draging_hover",
        "ins_left_position",
        "ins_inner_position",
        "ins_right_position",
        "ui_ins_drop_parent"
      );

      var o_end = rect.left + rect.width;
      if (rect.left < e.x && rect.left + rect.width / 4 > e.x) {
        o._addclass("ins_left_position");
      } else if (o_end > e.x && o_end - rect.width / 4 < e.x) {
        o._addclass("ins_right_position");
      } else if (o._getdata("append") === "inner") {
        o._addclass("ins_inner_position");
      }
      o._addclass("item_draging_hover");

      if (o._parents("." + t._classes.editor_block_container) instanceof INS) {
        o._parents("." + t._classes.editor_block_container)._addclass(
          "ui_ins_drop_parent"
        );
      }
    }
  });
};
ins_ui_editor.prototype._ajax = function (options, done, loadto) {
  var action_url = "/ins_lib/ui/ui_editor_db/update_blocks.php";
  var t = this;
  if (ins(loadto)._is_empty()) {
    loadto = ".ui_editor_view";
  }

  if (ins(".ui_editor")._is_exists(true)) {
    ins(loadto)._ui._addloader();
    options.pros = ins(".ui_editor")._getdata("pros");
    ins()._ajax._post({
      callback: function (data) {
        ins()._ui._removeloader();
        done(data);
        ins()._ui._update_ui();
        ins("." + t._classes.editor_block_act)._removeclass(
          t._classes.editor_block_act
        );
        if (!ins(t.act_object)._is_empty()) {
          t.act_object._addclass(t._classes.editor_block_act);
        }
      },
      url: action_url,
      options: options,
    });
  }
};

//<editor-fold defaultstate="collapsed" desc="History">

ins_ui_editor.prototype._history_btns_update = function () {
  if (this._data.ui_history_redo.length > 0) {
    ins(".ui_editor_redo")._removeclass("ins_ui_disabled");
    ins(".ui_menu_redo")._removeclass("ins_ui_disabled");
  } else {
    ins(".ui_editor_redo")._addclass("ins_ui_disabled");
    ins(".ui_menu_redo")._addclass("ins_ui_disabled");
  }
  if (this._data.ui_history.length > 0) {
    ins(".ui_menu_undo")._removeclass("ins_ui_disabled");
    ins(".ui_editor_undo")._removeclass("ins_ui_disabled");
  } else {
    ins(".ui_editor_undo")._addclass("ins_ui_disabled");
    ins(".ui_menu_undo")._addclass("ins_ui_disabled");
  }
};

ins_ui_editor.prototype._history_add = function (a) {
  this._data.ui_history.push(a);
  if (this._data.ui_history.length > this._options.history_limit) {
    this._data.ui_history.splice(0, 1);
  }

  this._history_btns_update();
};

ins_ui_editor.prototype._history_redo_add = function (a) {
  this._data.ui_history_redo.push(a);
  if (this._data.ui_history_redo.length > this._options.history_limit) {
    this._data.ui_history_redo.splice(0, 1);
  }
  this._history_btns_update();
};

ins_ui_editor.prototype._history_redo = function (e) {
  if (this._data.ui_history_redo.length > 0) {
    var indx = this._data.ui_history_redo.length - 1;
    var a = this._data.ui_history_redo[indx];
    this._data.ui_history_redo.splice(indx, 1);
    var s = this._history_undo_op(a);
    this._history_add({ obj: a.obj, type: a.type, settings: s });
    this._ui._send_info(ins_editor._t._msg.redo, { type: a.type });
  } else {
    this._ui._send_info(ins_editor._t._msg.redo_empty);
  }

  this._history_btns_update();
};

ins_ui_editor.prototype._history_undo = function (e) {
  if (this._data.ui_history.length > 0) {
    var indx = this._data.ui_history.length - 1;
    var a = this._data.ui_history[indx];

    this._data.ui_history.splice(indx, 1);
    var s = this._history_undo_op(a);
    this._history_redo_add({ obj: a.obj, type: a.type, settings: s });
    this._ui._send_info(ins_editor._t._msg.undo, { type: a.type });
  } else {
    this._ui._send_info(ins_editor._t._msg.undo_empty);
  }
  this._history_btns_update();
};

ins_ui_editor.prototype._history_undo_op = function (a) {
  var r = this._settings._console_get_code();
  this._settings._console_set_ins_code(a.settings);
  this._update_view();
  return r;
};
//</editor-fold>

ins_ui_editor.prototype._update_view = function () {
  var t = this;

  var jdata = this._settings._console_get_code();
  if (jdata !== false) {
    t._ui._send_info(ins_editor._t._msg.view_updateing);

    var options = {
      status: "ui_editor_update_all_view",
      data: jdata,
      css_data: this._settings._console_get_code(true, "css"),
      js_data: this._settings._console_get_code(true, "js"),
      data_file: ins(".ui_editor_view")._getdata("file"),
    };
    this._settings._update(null, null, false, false);

    this._ajax(options, function (data) {
      ins(".ui_editor_view")._sethtml(data);
      t._object.parseScript(data);
      t._ui._send_info(ins_editor._t._msg.view_updated);
    });
  } else {
    t._ui._send_info_error(t._t._msg.json_error);
  }
};

ins_ui_editor.prototype._take_image = function (callback, mode = null) {
  html2canvas(document.querySelector(".ui_editor_view")).then(function (
    canvas
  ) {
    var base64URL = canvas
      .toDataURL("image/jpeg")
      .replace("image/jpeg", "image/octet-stream");
    var options = { get_file: "/ins_ajax/eng/screenshot", image: base64URL };
    options.root = "true";
    if (mode !== null) {
      options.mode = mode;
    }
    ins()._ajax._post({
      url: "/ins_ajax.php",
      options: options,
      callback: function (d) {
        if (ins(callback)._is_exists()) {
          callback(JSON.parse(d));
        }
      },
    });
  });
};

ins_ui_editor.prototype._fast_save = function (e) {
  var t = this;
  this._ui._send_info(this._t._msg.editor_saveing);
  var cj = t._settings._console_get_code();

  if (cj !== false) {
    var options = {
      status: "ui_editor_update_ui_data",
      data: cj,
      css_data: t._settings._console_get_code(true, "css"),
      js_data: t._settings._console_get_code(true, "js"),
    };
    ins(".ui_save_loader")._css({ display: "block" });
    t._ajax(options, function () {
      ins(".ui_save_loader")._css({ display: "none" });
      t._update_view();
      t._ui._update_menu_area();
      t._ui._send_info(t._t._msg.editor_saved);
    });
  } else {
    t._ui._send_info_error(t._t._msg.json_error);
  }
};

ins_ui_editor.prototype._export = function (e) {
  let dataStr = this._settings._console_get_code();
  let dataUri =
    "data:application/json;charset=utf-8," + encodeURIComponent(dataStr);

  let exportFileDefaultName = "data.json";

  let linkElement = document.createElement("a");
  linkElement.setAttribute("href", dataUri);
  linkElement.setAttribute("download", exportFileDefaultName);
  linkElement.click();
};

ins_ui_editor.prototype._import = function (e) {};

ins_ui_editor.prototype._save = function (e) {
  var t = this;
  this._ui._send_info(this._t._msg.editor_saveing);
  this._take_image(function (data) {
    var options = {
      image: data.name,
      status: "ui_editor_update_ui_data",
      data: t._settings._console_get_code(),
      css_data: t._settings._console_get_code(true, "css"),
      js_data: t._settings._console_get_code(true, "js"),
    };
    ins(".ui_save_loader")._css({ display: "block" });
    t._ajax(options, function () {
      ins(".ui_save_loader")._css({ display: "none" });
      t._update_view();
      t._ui._update_menu_area();
      t._ui._send_info(t._t._msg.editor_saved);
    });
  }, "save");
};

ins_ui_editor.prototype._show_hide_grid = function () {
  if (ins(".ui_editor_grid")._hasclass("ins_hidden")) {
    ins(".ui_editor_grid")._removeclass("ins_hidden");
    ins(".ui_editor_style_grid")._addclass("ins_act");
  } else {
    ins(".ui_editor_grid")._addclass("ins_hidden");
    ins(".ui_editor_style_grid")._removeclass("ins_act");
  }
};

ins_ui_editor.prototype._zoom = function (e) {
  var o = ins(".ui_editor_view ");

  var v = this._object._get_transform_value("scale", [], 1, o);
  if (ins(e._getdata("value"))._is_exists()) {
    v = e._getdata("value");
    ins(".ui_editor_zoom.e_input")._setvalue(v * 100);
  } else if (ins(e._getdata("plus"))._is_exists()) {
    v = parseFloat(v) + parseFloat(e._getdata("plus"));
    ins(".ui_editor_zoom.e_input")._setvalue(v * 100);
  } else if (ins(e._getdata("minus"))._is_exists()) {
    v = parseFloat(v) - parseFloat(e._getdata("minus"));
    ins(".ui_editor_zoom.e_input")._setvalue(v * 100);
  } else {
    v = e._getvalue() / 100;
  }
  this._ui._send_info(this._t._msg.zoom_change, { value: v * 100 });
  o._css({ transform: this._object._get_transform("scale", "(" + v + ")", o) });
};

var ins_editor = new ins_ui_editor();

ins(function () {
  ins_editor._onstrat();
})._load();

//</editor-fold>

//</editor-fold>

function ui_update_img_src(val, src) {
  ins_editor._settings._update_one("src", val, true);
}

function ui_update_icon_settings(src) {
  var c = ins(ins()._getobj(src));

  ins_editor._settings._update_one("class", c._getattr("class"), true);
}

function ui_update_img_background(src, path) {
  ins_editor._object._change_css(
    "background-image",
    "url(" + path + ")",
    null,
    true
  );
}
function db_update_area() {
  ins_editor._ui._update_menu_area();
}

function menu_area() {
  ins_editor._ui._update_menu_area();
}
